searchNodes=[{"ref":"KafkaEx.html","title":"KafkaEx","type":"module","doc":"Kafka API This module is the main API for users of the KafkaEx library. Most of these functions either use the default worker (registered as :kafka_ex) by default or can take a registered name or pid via a worker_name option. # create an unnamed worker {:ok, pid} = KafkaEx.create_worker(:no_name) KafkaEx.fetch(&quot;some_topic&quot;, 0, worker_name: pid)"},{"ref":"KafkaEx.html#api_versions/1","title":"KafkaEx.api_versions/1","type":"function","doc":"Retrieve supported api versions for each api key."},{"ref":"KafkaEx.html#build_worker_options/1","title":"KafkaEx.build_worker_options/1","type":"function","doc":"Builds options to be used with workers Merges the given options with defaults from the application env config. Returns {:error, :invalid_consumer_options} if the consumer group configuration is invalid, and {:ok, merged_options} otherwise. Note this happens automatically when using KafkaEx.create_worker."},{"ref":"KafkaEx.html#consumer_group/1","title":"KafkaEx.consumer_group/1","type":"function","doc":"Returns the name of the consumer group for the given worker. Worker may be an atom or pid. The default worker is used by default."},{"ref":"KafkaEx.html#consumer_group_metadata/2","title":"KafkaEx.consumer_group_metadata/2","type":"function","doc":""},{"ref":"KafkaEx.html#create_topics/2","title":"KafkaEx.create_topics/2","type":"function","doc":"Create topics. Must provide a list of CreateTopicsRequest, each containing all the information needed for the creation of a new topic."},{"ref":"KafkaEx.html#create_worker/2","title":"KafkaEx.create_worker/2","type":"function","doc":"create_worker creates KafkaEx workers Optional arguments(KeywordList) consumer_group: Name of the group of consumers, :no_consumer_group should be passed for Kafka &lt; 0.8.2, defaults to Application.get_env(:kafka_ex, :consumer_group) uris: List of brokers in {&quot;host&quot;, port} or comma separated value &quot;host:port,host:port&quot; form, defaults to Application.get_env(:kafka_ex, :brokers) metadata_update_interval: How often kafka_ex would update the Kafka cluster metadata information in milliseconds, default is 30000 consumer_group_update_interval: How often kafka_ex would update the Kafka cluster consumer_groups information in milliseconds, default is 30000 use_ssl: Boolean flag specifying if ssl should be used for the connection by the worker to kafka, default is false ssl_options: see SSL OPTION DESCRIPTIONS - CLIENT SIDE at http://erlang.org/doc/man/ssl.html, default is [] Returns {:error, error_description} on invalid arguments Example iex&gt; KafkaEx.create_worker(:pr) # where :pr is the name of the worker created {:ok, #PID&lt;0.171.0&gt;} iex&gt; KafkaEx.create_worker(:pr, uris: [{&quot;localhost&quot;, 9092}]) {:ok, #PID&lt;0.172.0&gt;} iex&gt; KafkaEx.create_worker(:pr, [uris: [{&quot;localhost&quot;, 9092}], consumer_group: &quot;foo&quot;]) {:ok, #PID&lt;0.173.0&gt;} iex&gt; KafkaEx.create_worker(:pr, consumer_group: nil) {:error, :invalid_consumer_group}"},{"ref":"KafkaEx.html#delete_topics/2","title":"KafkaEx.delete_topics/2","type":"function","doc":"Delete topics. Must provide a list of topic names."},{"ref":"KafkaEx.html#earliest_offset/3","title":"KafkaEx.earliest_offset/3","type":"function","doc":"Get the offset of the earliest message still persistent in Kafka Example iex&gt; KafkaEx.earliest_offset(&quot;foo&quot;, 0) [%KafkaEx.Protocol.Offset.Response{partition_offsets: [%{error_code: 0, offset: [0], partition: 0}], topic: &quot;foo&quot;}]"},{"ref":"KafkaEx.html#fetch/3","title":"KafkaEx.fetch/3","type":"function","doc":"Fetch a set of messages from Kafka from the given topic and partition ID Optional arguments(KeywordList) offset: When supplied the fetch would start from this offset, otherwise would start from the last committed offset of the consumer_group the worker belongs to. For Kafka &lt; 0.8.2 you should explicitly specify this. worker_name: the worker we want to run this fetch request through. Default is :kafka_ex wait_time: maximum amount of time in milliseconds to block waiting if insufficient data is available at the time the request is issued. Default is 10 min_bytes: minimum number of bytes of messages that must be available to give a response. If the client sets this to 0 the server will always respond immediately, however if there is no new data since their last request they will just get back empty message sets. If this is set to 1, the server will respond as soon as at least one partition has at least 1 byte of data or the specified timeout occurs. By setting higher values in combination with the timeout the consumer can tune for throughput and trade a little additional latency for reading only large chunks of data (e.g. setting wait_time to 100 and setting min_bytes 64000 would allow the server to wait up to 100ms to try to accumulate 64k of data before responding). Default is 1 max_bytes: maximum bytes to include in the message set for this partition. This helps bound the size of the response. Default is 1,000,000 auto_commit: specifies if the last offset should be commited or not. Default is true. You must set this to false when using Kafka &lt; 0.8.2 or :no_consumer_group. api_version: Version of the Fetch API message to send (Kayrock client only, default: 0) offset_commit_api_version: Version of the OffsetCommit API message to send (Kayrock client only, only relevant for auto commit, default: 0, use 2+ to store offsets in Kafka instead of Zookeeper) Example iex&gt; KafkaEx.fetch(&quot;foo&quot;, 0, offset: 0) [ %KafkaEx.Protocol.Fetch.Response{partitions: [ %{error_code: 0, hw_mark_offset: 1, message_set: [ %{attributes: 0, crc: 748947812, key: nil, offset: 0, value: &quot;hey foo&quot;} ], partition: 0} ], topic: &quot;foo&quot;} ]"},{"ref":"KafkaEx.html#heartbeat/2","title":"KafkaEx.heartbeat/2","type":"function","doc":"Sends a heartbeat to maintain membership in a consumer group."},{"ref":"KafkaEx.html#join_group/2","title":"KafkaEx.join_group/2","type":"function","doc":"Sends a request to join a consumer group."},{"ref":"KafkaEx.html#latest_offset/3","title":"KafkaEx.latest_offset/3","type":"function","doc":"Get the offset of the latest message written to Kafka Example iex&gt; KafkaEx.latest_offset(&quot;foo&quot;, 0) [%KafkaEx.Protocol.Offset.Response{partition_offsets: [%{error_code: 0, offsets: [16], partition: 0}], topic: &quot;foo&quot;}]"},{"ref":"KafkaEx.html#leave_group/2","title":"KafkaEx.leave_group/2","type":"function","doc":"Sends a request to leave a consumer group."},{"ref":"KafkaEx.html#metadata/1","title":"KafkaEx.metadata/1","type":"function","doc":"Return metadata for the given topic; returns for all topics if topic is empty string Optional arguments(KeywordList) worker_name: the worker we want to run this metadata request through, when none is provided the default worker :kafka_ex is used topic: name of the topic for which metadata is requested, when none is provided all metadata is retrieved Example iex&gt; KafkaEx.create_worker(:mt) iex&gt; KafkaEx.metadata(topic: &quot;foo&quot;, worker_name: :mt) %KafkaEx.Protocol.Metadata.Response{brokers: [%KafkaEx.Protocol.Metadata.Broker{host: &quot;192.168.59.103&quot;, node_id: 49162, port: 49162, socket: nil}], topic_metadatas: [%KafkaEx.Protocol.Metadata.TopicMetadata{error_code: 0, partition_metadatas: [%KafkaEx.Protocol.Metadata.PartitionMetadata{error_code: 0, isrs: [49162], leader: 49162, partition_id: 0, replicas: [49162]}], topic: &quot;foo&quot;}]}"},{"ref":"KafkaEx.html#offset/4","title":"KafkaEx.offset/4","type":"function","doc":"Get the offset of the message sent at the specified date/time Example iex&gt; KafkaEx.offset(&quot;foo&quot;, 0, {{2015, 3, 29}, {23, 56, 40}}) # Note that the time specified should match/be ahead of time on the server that kafka runs [%KafkaEx.Protocol.Offset.Response{partition_offsets: [%{error_code: 0, offset: [256], partition: 0}], topic: &quot;foo&quot;}]"},{"ref":"KafkaEx.html#offset_commit/2","title":"KafkaEx.offset_commit/2","type":"function","doc":""},{"ref":"KafkaEx.html#offset_fetch/2","title":"KafkaEx.offset_fetch/2","type":"function","doc":""},{"ref":"KafkaEx.html#produce/2","title":"KafkaEx.produce/2","type":"function","doc":"Produces batch messages to kafka logs Optional arguments(KeywordList) worker_name: the worker we want to run this metadata request through, when none is provided the default worker :kafka_ex is used Example iex&gt; KafkaEx.produce(%KafkaEx.Protocol.Produce.Request{topic: &quot;foo&quot;, partition: 0, required_acks: 1, messages: [%KafkaEx.Protocol.Produce.Message{value: &quot;hey&quot;}]}) {:ok, 9772} iex&gt; KafkaEx.produce(%KafkaEx.Protocol.Produce.Request{topic: &quot;foo&quot;, partition: 0, required_acks: 1, messages: [%KafkaEx.Protocol.Produce.Message{value: &quot;hey&quot;}]}, worker_name: :pr) {:ok, 9773}"},{"ref":"KafkaEx.html#produce/4","title":"KafkaEx.produce/4","type":"function","doc":"Produces messages to kafka logs (this is deprecated, use KafkaEx.produce/2 instead) Optional arguments(KeywordList) worker_name: the worker we want to run this metadata request through, when none is provided the default worker :kafka_ex is used key: is used for partition assignment, can be nil, when none is provided it is defaulted to nil required_acks: indicates how many acknowledgements the servers should receive before responding to the request. If it is 0 the server will not send any response (this is the only case where the server will not reply to a request). If it is 1, the server will wait the data is written to the local log before sending a response. If it is -1 the server will block until the message is committed by all in sync replicas before sending a response. For any number &gt; 1 the server will block waiting for this number of acknowledgements to occur (but the server will never wait for more acknowledgements than there are in-sync replicas), default is 0 timeout: provides a maximum time in milliseconds the server can await the receipt of the number of acknowledgements in RequiredAcks, default is 100 milliseconds compression: specifies the compression type (:none, :snappy, :gzip) api_version: Version of the Fetch API message to send (Kayrock client only, default: 0) timestamp: unix epoch timestamp in milliseconds for the message (Kayrock client only, default: nil, must be using api_version &gt;= 3) Example iex&gt; KafkaEx.produce(&quot;bar&quot;, 0, &quot;hey&quot;) :ok iex&gt; KafkaEx.produce(&quot;foo&quot;, 0, &quot;hey&quot;, [worker_name: :pr, required_acks: 1]) {:ok, 9771}"},{"ref":"KafkaEx.html#start/2","title":"KafkaEx.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"KafkaEx.html#start_link_worker/2","title":"KafkaEx.start_link_worker/2","type":"function","doc":"Start and link a worker outside of a supervision tree This takes the same arguments as create_worker/2 except that it adds server_impl - This is the GenServer that will be used for the client genserver implementation - e.g., KafkaEx.Server0P8P0, KafkaEx.Server0P10AndLater, KafkaEx.New.Client. Defaults to the value determined by the kafka_version setting."},{"ref":"KafkaEx.html#stop_worker/1","title":"KafkaEx.stop_worker/1","type":"function","doc":"Stop a worker created with create_worker/2 Returns :ok on success or :error if worker is not a valid worker"},{"ref":"KafkaEx.html#stream/3","title":"KafkaEx.stream/3","type":"function","doc":"Returns a streamable struct that may be used for consuming messages. The returned struct is compatible with the Stream and Enum modules. Some important usage notes follow; see below for a detailed list of options. iex&gt; KafkaEx.produce(&quot;foo&quot;, 0, &quot;hey&quot;) :ok iex&gt; KafkaEx.produce(&quot;foo&quot;, 0, &quot;hi&quot;) :ok iex&gt; stream = KafkaEx.stream(&quot;foo&quot;, 0) %KafkaEx.Stream{...} iex&gt; Enum.take(stream, 2) [%KafkaEx.Protocol.Fetch.Message{attributes: 0, crc: 1784030606, key: &quot;&quot;, offset: 0, value: &quot;hey&quot;}, %KafkaEx.Protocol.Fetch.Message{attributes: 0, crc: 3776653906, key: &quot;&quot;, offset: 1, value: &quot;hi&quot;}] iex&gt; stream |&gt; Stream.map(fn(msg) -&gt; IO.puts(msg.value) end) |&gt; Stream.run &quot;hey&quot; &quot;hi&quot; # NOTE this will block! See below. Reusing streams Reusing the same KafkaEx.Stream struct results in consuming the same messages multiple times. This is by design and mirrors the functionality of File.stream!/3. If you want to reuse the same stream struct, update its :offset before reuse. iex&gt; stream = KafkaEx.stream(&quot;foo&quot;, 0) iex&gt; [m1, m2] = Enum.take(stream, 2) iex&gt; [m1, m2] = Enum.take(stream, 2) # these will be the same messages iex&gt; stream = %{stream | fetch_request: %{stream.fetch_request | offset: m2.offset + 1}} iex&gt; [m3, m4] = Enum.take(stream, 2) # new messages Streams block at log end By default, the stream consumes indefinitely and will block at log end until new messages are available. Use the no_wait_at_logend: true option to have the stream halt when no more messages are available. This mirrors the command line arguments of SimpleConsumerShell. Note that this means that fetches will return up to as many messages as are immediately available in the partition, regardless of arguments. iex&gt; Enum.map(1..3, fn(ix) -&gt; KafkaEx.produce(&quot;bar&quot;, 0, &quot;Msg \#{ix}&quot;) end) iex&gt; stream = KafkaEx.stream(&quot;bar&quot;, 0, no_wait_at_logend: true, offset: 0) iex&gt; Enum.map(stream, fn(m) -&gt; m.value end) # does not block [&quot;Msg 1&quot;, &quot;Msg 2&quot;, &quot;Msg 3&quot;] iex&gt; stream |&gt; Stream.map(fn(m) -&gt; m.value end) |&gt; Enum.take(10) # only 3 messages are available [&quot;Msg 1&quot;, &quot;Msg 2&quot;, &quot;Msg 3&quot;] Consumer group and auto commit If you pass a value for the consumer_group option and true for auto_commit, the offset of the last message consumed will be committed to the broker during each cycle. For example, suppose we start at the beginning of a partition with millions of messages and the max_bytes setting is such that each fetch request gets 25 messages. In this setting, we will (roughly) be committing offsets 25, 50, 75, etc. Note that offsets are committed immediately after messages are retrieved and before you know if you have successfully consumed them. It is therefore possible that you could miss messages if your consumer crashes in the middle of consuming a batch, effectively losing the guarantee of at-least-once delivery. If you need this guarantee, we recommend that you construct a GenServer-based consumer module and manage your commits manually. iex&gt; Enum.map(1..10, fn(ix) -&gt; KafkaEx.produce(&quot;baz&quot;, 0, &quot;Msg \#{ix}&quot;) end) iex&gt; stream = KafkaEx.stream(&quot;baz&quot;, 0, consumer_group: &quot;my_consumer&quot;, auto_commit: true) iex&gt; stream |&gt; Enum.take(2) |&gt; Enum.map(fn(msg) -&gt; msg.value end) [&quot;Msg 1&quot;, &quot;Msg 2&quot;] iex&gt; stream |&gt; Enum.take(2) |&gt; Enum.map(fn(msg) -&gt; msg.value end) [&quot;Msg 1&quot;, &quot;Msg 2&quot;] # same values iex&gt; stream2 = KafkaEx.stream(&quot;baz&quot;, 0, consumer_group: &quot;my_consumer&quot;, auto_commit: true) iex&gt; stream2 |&gt; Enum.take(1) |&gt; Enum.map(fn(msg) -&gt; msg.value end) [&quot;Msg 3&quot;] # stream2 got the next available offset Options KafkaEx.stream/3 accepts a keyword list of options for the third argument. no_wait_at_logend (boolean): Set this to true to halt the stream when there are no more messages available. Defaults to false, i.e., the stream blocks to wait for new messages. worker_name (term): The KafkaEx worker to use for communication with the brokers. Defaults to :kafka_ex (the default worker). consumer_group (string): Name of the consumer group used for the initial offset fetch and automatic offset commit (if auto_commit is true). Omit this value or use :no_consumer_group to not use a consumer group (default). Consumer groups are not compatible with Kafka &lt; 0.8.2. offset (integer): The offset from which to start fetching. By default, this is the last available offset of the partition when no consumer group is specified. When a consumer group is specified, the next message after the last committed offset is used. For Kafka &lt; 0.8.2 you must explicitly specify an offset. auto_commit (boolean): If true, the stream automatically commits offsets of fetched messages. See discussion above. api_versions (map): Allows overriding api versions for :fetch, :offset_fetch, and :offset_commit when using the Kayrock client. Defaults to %{fetch: 0, offset_fetch: 0, offset_commit: 0}. Use %{fetch: 3, offset_fetch: 3, offset_commit: 3} with the kayrock client to achieve offsets stored in kafka (instead of zookeeper) and messages fetched with timestamps."},{"ref":"KafkaEx.html#sync_group/2","title":"KafkaEx.sync_group/2","type":"function","doc":"Sends a request to synchronize with a consumer group."},{"ref":"KafkaEx.html#valid_consumer_group?/1","title":"KafkaEx.valid_consumer_group?/1","type":"function","doc":"Returns true if the input is a valid consumer group or :no_consumer_group"},{"ref":"KafkaEx.html#t:ssl_options/0","title":"KafkaEx.ssl_options/0","type":"type","doc":""},{"ref":"KafkaEx.html#t:uri/0","title":"KafkaEx.uri/0","type":"type","doc":""},{"ref":"KafkaEx.html#t:worker_init/0","title":"KafkaEx.worker_init/0","type":"type","doc":""},{"ref":"KafkaEx.html#t:worker_setting/0","title":"KafkaEx.worker_setting/0","type":"type","doc":""},{"ref":"KafkaEx.Compression.html","title":"KafkaEx.Compression","type":"module","doc":"Handles compression/decompression of messages. See https://cwiki.apache.org/confluence/display/KAFKA/A+Guide+To+The+Kafka+Protocol#AGuideToTheKafkaProtocol-Compression To add new compression types: Add the appropriate dependency to mix.exs (don&#39;t forget to add it to the application list). Add the appropriate attribute value and compression_type atom. Add a decompress function clause. Add a compress function clause."},{"ref":"KafkaEx.Compression.html#compress/2","title":"KafkaEx.Compression.compress/2","type":"function","doc":"This function should pattern match on the compression_type atom and return the compressed data as well as the corresponding attribute value."},{"ref":"KafkaEx.Compression.html#decompress/2","title":"KafkaEx.Compression.decompress/2","type":"function","doc":"This function should pattern match on the attribute value and return the decompressed data."},{"ref":"KafkaEx.Compression.html#snappy_decompress_chunk/2","title":"KafkaEx.Compression.snappy_decompress_chunk/2","type":"function","doc":""},{"ref":"KafkaEx.Compression.html#t:attribute_t/0","title":"KafkaEx.Compression.attribute_t/0","type":"type","doc":""},{"ref":"KafkaEx.Compression.html#t:compression_type_t/0","title":"KafkaEx.Compression.compression_type_t/0","type":"type","doc":""},{"ref":"KafkaEx.Config.html","title":"KafkaEx.Config","type":"module","doc":"Configuring KafkaEx use Mix.Config config :kafka_ex, # A list of brokers to connect to. This can be in either of the following formats # # * [{&quot;HOST&quot;, port}...] # * CSV - `&quot;HOST:PORT,HOST:PORT[,...]&quot;` # * {mod, fun, args} # * &amp;arity_zero_fun/0 # * fn -&gt; ... end # # If you receive :leader_not_available # errors when producing messages, it may be necessary to modify &quot;advertised.host.name&quot; in the # server.properties file. # In the case below you would set &quot;advertised.host.name=localhost&quot; brokers: [ {&quot;localhost&quot;, 9093}, {&quot;localhost&quot;, 9094}, {&quot;localhost&quot;, 9095} ], # # OR: # brokers: &quot;localhost:9092,localhost:9093,localhost:9094&quot; # # It may be useful to configure your brokers at runtime, for example if you use # service discovery instead of storing your broker hostnames in a config file. # To do this, you can use `{mod, fun, args}` or a zero-arity function, and [`KafkaEx`](KafkaEx.html) # will invoke your callback when fetching the `:brokers` configuration. # Note that when using this approach you must return a list of host/port pairs. # # the default consumer group for worker processes, must be a binary (string) # NOTE if you are on Kafka &lt; 0.8.2 or if you want to disable the use of # consumer groups, set this to :no_consumer_group (this is the # only exception to the requirement that this value be a binary) consumer_group: &quot;kafka_ex&quot;, # The client_id is the logical grouping of a set of kafka clients. client_id: &quot;kafka_ex&quot;, # Set this value to true if you do not want the default # [`KafkaEx.Server`](KafkaEx.Server.html) worker to start during application start-up - # i.e., if you want to start your own set of named workers disable_default_worker: false, # Timeout value, in msec, for synchronous operations (e.g., network calls). # If this value is greater than GenServer&#39;s default timeout of 5000, it will also # be used as the timeout for work dispatched via KafkaEx.Server.call (e.g., KafkaEx.metadata). # In those cases, it should be considered a &#39;total timeout&#39;, encompassing both network calls and # wait time for the genservers. sync_timeout: 3000, # Supervision max_restarts - the maximum amount of restarts allowed in a time frame max_restarts: 10, # Supervision max_seconds - the time frame in which :max_restarts applies max_seconds: 60, # Interval in milliseconds that GenConsumer waits to commit offsets. commit_interval: 5_000, # Threshold number of messages consumed for GenConsumer to commit offsets # to the broker. commit_threshold: 100, # Interval in milliseconds to wait before reconnect to kafka sleep_for_reconnect: 400, # This is the flag that enables use of ssl use_ssl: true, # see SSL OPTION DESCRIPTIONS - CLIENT SIDE at http://erlang.org/doc/man/ssl.html # for supported options ssl_options: [ cacertfile: File.cwd!() &lt;&gt; &quot;/ssl/ca-cert&quot;, certfile: File.cwd!() &lt;&gt; &quot;/ssl/cert.pem&quot;, keyfile: File.cwd!() &lt;&gt; &quot;/ssl/key.pem&quot; ], # set this to the version of the kafka broker that you are using # include only major.minor.patch versions. must be at least 0.8.0 # use &quot;kayrock&quot; for the new client kafka_version: &quot;0.10.1&quot; env_config = Path.expand(&quot;\#{Mix.env()}.exs&quot;, __DIR__) if File.exists?(env_config) do import_config(env_config) end"},{"ref":"KafkaEx.ConsumerGroup.html","title":"KafkaEx.ConsumerGroup","type":"module","doc":"A process that manages membership in a Kafka consumer group. Consumers in a consumer group coordinate with each other through a Kafka broker to distribute the work of consuming one or several topics without any overlap. This is facilitated by the Kafka client-side assignment protocol. Any time group membership changes (a member joins or leaves the group), a Kafka broker initiates group synchronization by asking one of the group members (the leader elected by the broker) to provide partition assignments for the whole group. KafkaEx uses a round robin partition assignment algorithm by default. This can be overridden by passing a callback function in the :partition_assignment_callback option. See KafkaEx.ConsumerGroup.PartitionAssignment for details on partition assignment functions. A KafkaEx.ConsumerGroup process is responsible for: Maintaining membership in a Kafka consumer group. Determining partition assignments if elected as the group leader. Launching and terminating KafkaEx.GenConsumer processes based on its assigned partitions. To use a KafkaEx.ConsumerGroup, a developer must define a module that implements the KafkaEx.GenConsumer behaviour and start a KafkaEx.ConsumerGroup configured to use that module. The api versions of some of the underlying messages can be specified in the :api_versions option. Note that these will be ignored (api version 0 used) unless you have kafka_version: &quot;kayrock&quot; set in the KafkaEx application config. The following versions can be specified: :fetch - Fetch requests - use v2+ for newer versions of Kafka :offset_fetch - Offset fetch requests - use v1+ for offsets stored in Kafka (as opposed to zookeeper) :offset_commit - Offset commit requests - use v1+ to store offsets in Kafka (as opposed to zookeeper) Example Suppose we want to consume from a topic called &quot;example_topic&quot; with a consumer group named &quot;example_group&quot; and we have a KafkaEx.GenConsumer implementation called ExampleGenConsumer (see the KafkaEx.GenConsumer documentation). We could start a consumer group in our application&#39;s supervision tree as follows: defmodule MyApp do use Application def start(_type, _args) do import Supervisor.Spec consumer_group_opts = [ # setting for the ConsumerGroup heartbeat_interval: 1_000, # this setting will be forwarded to the GenConsumer commit_interval: 1_000 ] gen_consumer_impl = ExampleGenConsumer consumer_group_name = &quot;example_group&quot; topic_names = [&quot;example_topic&quot;] children = [ # ... other children supervisor( KafkaEx.ConsumerGroup, [gen_consumer_impl, consumer_group_name, topic_names, consumer_group_opts] ) ] Supervisor.start_link(children, strategy: :one_for_one) end end Note It is not necessary for the Elixir nodes in a consumer group to be connected (i.e., using distributed Erlang methods). The coordination of group consumers is mediated by the broker. See start_link/4 for configuration details."},{"ref":"KafkaEx.ConsumerGroup.html#active?/2","title":"KafkaEx.ConsumerGroup.active?/2","type":"function","doc":"Returns true if at least one child consumer process is alive"},{"ref":"KafkaEx.ConsumerGroup.html#assignments/2","title":"KafkaEx.ConsumerGroup.assignments/2","type":"function","doc":"Returns a list of topic and partition assignments for which this consumer is responsible. These are assigned by the leader and communicated by the broker on sync."},{"ref":"KafkaEx.ConsumerGroup.html#child_spec/1","title":"KafkaEx.ConsumerGroup.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"KafkaEx.ConsumerGroup.html#consumer_pids/1","title":"KafkaEx.ConsumerGroup.consumer_pids/1","type":"function","doc":"Returns the pids of consumer processes"},{"ref":"KafkaEx.ConsumerGroup.html#consumer_supervisor_pid/2","title":"KafkaEx.ConsumerGroup.consumer_supervisor_pid/2","type":"function","doc":"Returns the pid of the KafkaEx.GenConsumer.Supervisor that supervises this member&#39;s consumers. Returns nil if called before the initial sync."},{"ref":"KafkaEx.ConsumerGroup.html#generation_id/2","title":"KafkaEx.ConsumerGroup.generation_id/2","type":"function","doc":"Returns the generation id of the consumer group. The generation id is provided by the broker on sync. Returns nil if queried before the initial sync has completed."},{"ref":"KafkaEx.ConsumerGroup.html#get_manager_pid/1","title":"KafkaEx.ConsumerGroup.get_manager_pid/1","type":"function","doc":"Returns the pid of the KafkaEx.ConsumerGroup.Manager process for the given consumer group supervisor. Intended for introspection usage only."},{"ref":"KafkaEx.ConsumerGroup.html#group_name/2","title":"KafkaEx.ConsumerGroup.group_name/2","type":"function","doc":"Returns the name of the consumer group"},{"ref":"KafkaEx.ConsumerGroup.html#leader?/2","title":"KafkaEx.ConsumerGroup.leader?/2","type":"function","doc":"Returns true if this consumer is the leader of the consumer group Leaders are elected by the broker and are responsible for assigning partitions. Returns false if queried before the intiial sync has completed."},{"ref":"KafkaEx.ConsumerGroup.html#leader_id/2","title":"KafkaEx.ConsumerGroup.leader_id/2","type":"function","doc":"Returns the member id of the consumer group&#39;s leader This is provided by the broker on sync. Returns nil if queried before the initial sync has completed"},{"ref":"KafkaEx.ConsumerGroup.html#member_id/2","title":"KafkaEx.ConsumerGroup.member_id/2","type":"function","doc":"Returns the consumer group member id The id is assigned by the broker. Returns nil if queried before the initial sync has completed."},{"ref":"KafkaEx.ConsumerGroup.html#partition_consumer_map/1","title":"KafkaEx.ConsumerGroup.partition_consumer_map/1","type":"function","doc":"Returns a map from {topic, partition_id} to consumer pid"},{"ref":"KafkaEx.ConsumerGroup.html#start_link/4","title":"KafkaEx.ConsumerGroup.start_link/4","type":"function","doc":"Starts a consumer group process tree process linked to the current process. This can be used to start a KafkaEx.ConsumerGroup as part of a supervision tree. consumer_module is a module that implements the KafkaEx.GenConsumer behaviour. a tuple of {gen_consumer_module, consumer_module} can substitute another GenServer implementation for KafkaEx.GenConsumer. When a single module is passed it is transformed to {KafkaEx.GenConsumer, consumer_module}. group_name is the name of the consumer group. topics is a list of topics that the consumer group should consume from. opts can be composed of options for the supervisor as well as for the KafkEx.GenConsumer processes that will be spawned by the supervisor. See option/0 for details. Note When starting a consumer group with multiple topics, you should propagate this configuration change to your consumers. If you add a topic to an existing consumer group from a single consumer, it may take a long time to propagate depending on the leader election process. Return Values This function has the same return values as Supervisor.start_link/3."},{"ref":"KafkaEx.ConsumerGroup.html#t:option/0","title":"KafkaEx.ConsumerGroup.option/0","type":"type","doc":"Option values used when starting a consumer group :heartbeat_interval - How frequently, in milliseconds, to send heartbeats to the broker. This impacts how quickly we will process partition changes as consumers start/stop. Default: 5000 (5 seconds). :session_timeout - Consumer group session timeout in milliseconds. Default: 30000 (30 seconds). See below. :session_timeout_padding - Timeout padding for consumer group options. Default: 10000 (10 seconds). See below. Any of KafkaEx.GenConsumer.option/0, which will be passed on to consumers :gen_server_opts - GenServer.options/0 passed on to the manager GenServer :name - Name for the consumer group supervisor :max_restarts, :max_seconds - Supervisor restart policy parameters :partition_assignment_callback - See KafkaEx.ConsumerGroup.PartitionAssignment.callback/0 :uris - See KafkaEx.create_worker/2 Note :session_timeout is registered with the broker and determines how long before the broker will de-register a consumer from which it has not heard a heartbeat. This value must between the broker cluster&#39;s configured values for group.min.session.timeout.ms and group.max.session.timeout.ms (6000 and 30000 by default). See https://kafka.apache.org/documentation/#configuration. You may need to adjust session_timeout_padding on high-latency clusters to avoid timing out when joining/syncing consumer groups."},{"ref":"KafkaEx.ConsumerGroup.html#t:options/0","title":"KafkaEx.ConsumerGroup.options/0","type":"type","doc":""},{"ref":"KafkaEx.ConsumerGroup.PartitionAssignment.html","title":"KafkaEx.ConsumerGroup.PartitionAssignment","type":"module","doc":"Contains typespecs and reference algorithms for assigning partitions round_robin/2 is used by KafkaEx.ConsumerGroup by default and should suffice in most cases. For custom assignments, any function matching the callback/0 type spec can be used."},{"ref":"KafkaEx.ConsumerGroup.PartitionAssignment.html#round_robin/2","title":"KafkaEx.ConsumerGroup.PartitionAssignment.round_robin/2","type":"function","doc":"Round robin assignment Iterates over the partitions and members, giving the first member the first partition, the second member the second partition, etc, looping back to the beginning of the list of members when finished. Example: iex&gt; KafkaEx.ConsumerGroup.PartitionAssignment([&quot;m1&quot;, &quot;m2&quot;], [{&quot;t1&quot;, 0}, {&quot;t2, 1&quot;}, {&quot;t3&quot;, 2}]) %{&quot;m1&quot; =&gt; [{&quot;t1&quot;, 0}, {&quot;t3&quot;, 2}], &quot;m2&quot; =&gt; [{&quot;t2&quot;, 1}]}"},{"ref":"KafkaEx.ConsumerGroup.PartitionAssignment.html#t:callback/0","title":"KafkaEx.ConsumerGroup.PartitionAssignment.callback/0","type":"type","doc":"A function that can assign partitions. members is a list of member IDs and partitions is a list of partitions that need to be assigned to a group member. The return value must be a map with member IDs as keys and a list of partition assignments as values. For each member ID in the returned map, the assigned partitions will become the assignments argument to KafkaEx.GenConsumer.Supervisor.start_link/4 in the corresponding member process. Any member that&#39;s omitted from the return value will not be assigned any partitions. Example Given the following members and partitions to be assigned: members = [&quot;member1&quot;, &quot;member2&quot;, &quot;member3&quot;] partitions = [{&quot;topic&quot;, 0}, {&quot;topic&quot;, 1}, {&quot;topic&quot;, 2}] One possible assignment is as follows: ExampleGenConsumer.assign_partitions(members, partitions) #=&gt; %{&quot;member1&quot; =&gt; [{&quot;topic&quot;, 0}, {&quot;topic&quot;, 2}], &quot;member2&quot; =&gt; [{&quot;topic&quot;, 1}]} In this case, the consumer group process for &quot;member1&quot; will launch two KafkaEx.GenConsumer processes (one for each of its assigned partitions), &quot;member2&quot; will launch one KafkaEx.GenConsumer process, and &quot;member3&quot; will launch no processes."},{"ref":"KafkaEx.ConsumerGroup.PartitionAssignment.html#t:member_id/0","title":"KafkaEx.ConsumerGroup.PartitionAssignment.member_id/0","type":"type","doc":"The ID (string) of a member of a consumer group, assigned by a Kafka broker."},{"ref":"KafkaEx.ConsumerGroup.PartitionAssignment.html#t:partition/0","title":"KafkaEx.ConsumerGroup.PartitionAssignment.partition/0","type":"type","doc":"A partition of a single topic (embeds the name of the topic)."},{"ref":"KafkaEx.ConsumerGroup.PartitionAssignment.html#t:partition_id/0","title":"KafkaEx.ConsumerGroup.PartitionAssignment.partition_id/0","type":"type","doc":"The integer ID of a partition of a Kafka topic."},{"ref":"KafkaEx.ConsumerGroup.PartitionAssignment.html#t:topic/0","title":"KafkaEx.ConsumerGroup.PartitionAssignment.topic/0","type":"type","doc":"The string name of a Kafka topic."},{"ref":"KafkaEx.ConsumerGroupRequiredError.html","title":"KafkaEx.ConsumerGroupRequiredError","type":"exception","doc":""},{"ref":"KafkaEx.DefaultPartitioner.html","title":"KafkaEx.DefaultPartitioner","type":"module","doc":"Default partitioner implementation. When message key is set and partition isn&#39;t, partition is decided based on murmur2 hash of a key to provide Java implementation consistency. When message key and partition is missing, partition is selected randomly. When partition is provided nothing changes."},{"ref":"KafkaEx.DefaultPartitioner.html#assign_partition/2","title":"KafkaEx.DefaultPartitioner.assign_partition/2","type":"function","doc":"Callback implementation for KafkaEx.Partitioner.assign_partition/2."},{"ref":"KafkaEx.GenConsumer.html","title":"KafkaEx.GenConsumer","type":"behaviour","doc":"A behaviour module for implementing a Kafka consumer. A KafkaEx.GenConsumer is an Elixir process that consumes messages from Kafka. A single KafkaEx.GenConsumer process consumes from a single partition of a Kafka topic. Several KafkaEx.GenConsumer processes can be used to consume from multiple partitions or even multiple topics. Partition assignments for a group of KafkaEx.GenConsumers can be defined manually using KafkaEx.GenConsumer.Supervisor or coordinated across a cluster of nodes using KafkaEx.ConsumerGroup. A KafkaEx.GenConsumer must implement three callbacks. Two of these will be defined with default behavior if you add use KafkaEx.GenConsumer to your module, leaving just handle_message_set/2 to be implemented. This is the recommended usage. Example The KafkaEx.GenConsumer behaviour abstracts common Kafka consumer interactions. KafkaEx.GenConsumer will take care of the details of determining a starting offset, fetching messages from a Kafka broker, and committing offsets for consumed messages. Developers are only required to implement handle_message_set/2 to process messages. The following is a minimal example that logs each message as it&#39;s consumed: defmodule ExampleGenConsumer do use KafkaEx.GenConsumer alias KafkaEx.Protocol.Fetch.Message require Logger # note - messages are delivered in batches def handle_message_set(message_set, state) do for %Message{value: message} &lt;- message_set do Logger.debug(fn -&gt; &quot;message: &quot; &lt;&gt; inspect(message) end) end {:async_commit, state} end end handle_message_set/2 will be called with the batch of messages fetched from the broker. The number of messages in a batch is determined by the number of messages available and the max_bytes and min_bytes parameters of the fetch request (which can be configured in KafkaEx). In this example, because handle_message_set/2 always returns {:async_commit, new_state}, the message offsets will be automatically committed asynchronously. Committing Offsets KafkaEx.GenConsumer manages a consumer&#39;s offsets by committing the offsets of consumed messages. KafkaEx supports two commit strategies: asynchronous and synchronous. The return value of handle_message_set/2 determines which strategy is used: {:sync_commit, new_state} causes synchronous offset commits. {:async_commit, new_state} causes asynchronous offset commits. Note that with both of the offset commit strategies, only if the final offset in the message set is committed and this is done after the messages are consumed. If you want to commit the offset of every message consumed, use the synchronous offset commit strategy and implement calls to KafkaEx.offset_commit/2 within your consumer as appropriate. Synchronous offset commits When handle_message_set/2 returns {:sync_commit, new_state}, the offset of the final message in the message set is committed immediately before fetching any more messages. This strategy requires a significant amount of communication with the broker and could correspondingly degrade consumer performance, but it will keep the offset commits tightly synchronized with the consumer state. Choose the synchronous offset commit strategy if you want to favor consistency of offset commits over performance, or if you have a low rate of message arrival. The definition of a &quot;low rate&quot; depends on the situation, but tens of messages per second could be considered a &quot;low rate&quot; in most situations. Asynchronous offset commits When handle_message_set/2 returns {:async_commit, new_state}, KafkaEx will not commit offsets after every message set consumed. To avoid excessive network calls, the offsets are committed periodically (and when the worker terminates). How often a KafkaEx.GenConsumer auto-commits offsets is controlled by the two configuration values :commit_interval and :commit_threshold. :commit_interval is the maximum time (in milliseconds) that a KafkaEx.GenConsumer will delay committing the offset for an acknowledged message. :commit_threshold is the maximum number of acknowledged messages that a KafkaEx.GenConsumer will allow to be uncommitted before triggering a commit. These can be set globally in the :kafka_ex app&#39;s environment or on a per-consumer basis by passing options to start_link/5: # In config/config.exs config :kafka_ex, commit_interval: 5000, commit_threshold: 100 # As options to start_link/5 KafkaEx.GenConsumer.start_link(MyConsumer, &quot;my_group&quot;, &quot;topic&quot;, 0, commit_interval: 5000, commit_threshold: 100) For low-volume topics, :commit_interval is the dominant factor for how often a KafkaEx.GenConsumer auto-commits. For high-volume topics, :commit_threshold is the dominant factor. Handler state and interaction Use the init/2 to initialize consumer state and handle_call/3, handle_cast/2, or handle_info/2 to interact. Example: defmodule MyConsumer do use KafkaEx.GenConsumer defmodule State do defstruct messages: [], calls: 0 end def init(_topic, _partition) do {:ok, %State{}} end def init(_topic, _partition, extra_args) do {:ok, %State{}} end def handle_message_set(message_set, state) do {:async_commit, %{state | messages: state.messages ++ message_set}} end def handle_call(:messages, _from, state) do {:reply, state.messages, %{state | calls: state.calls + 1}} end end {:ok, pid} = GenConsumer.start_link(MyConsumer, &quot;consumer_group&quot;, &quot;topic&quot;, 0) GenConsumer.call(pid, :messages) NOTE If you do not implement handle_call/3 or handle_cast/2, any calls to GenConsumer.call/3 or casts to GenConsumer.cast/2 will raise an error. Similarly, any messages sent to a GenConsumer will log an error if there is no corresponding handle_info/2 callback defined. Testing A KafkaEx.GenConsumer can be unit-tested without a running Kafka broker by sending messages directly to its handle_message_set/2 function. The following recipe can be used as a starting point when testing a KafkaEx.GenConsumer: defmodule ExampleGenConsumerTest do use ExUnit.Case, async: true alias KafkaEx.Protocol.Fetch.Message @topic &quot;topic&quot; @partition 0 setup do {:ok, state} = ExampleGenConsumer.init(@topic, @partition) {:ok, %{state: state}} end test &quot;it acks a message&quot;, %{state: state} do message_set = [%Message{offset: 0, value: &quot;hello&quot;}] {response, _new_state} = ExampleGenConsumer.handle_message_set(message_set, state) assert response == :async_commit end end"},{"ref":"KafkaEx.GenConsumer.html#call/3","title":"KafkaEx.GenConsumer.call/3","type":"function","doc":"Forwards a GenServer.call/3 to the consumer implementation with the consumer&#39;s state. The implementation must return a GenServer.call/3-compatible value of the form {:reply, reply_value, new_consumer_state}. The GenConsumer will turn this into an immediate timeout, which drives continued message consumption. See the moduledoc for an example."},{"ref":"KafkaEx.GenConsumer.html#cast/2","title":"KafkaEx.GenConsumer.cast/2","type":"function","doc":"Forwards a GenServer.cast/2 to the consumer implementation with the consumer&#39;s state. The implementation must return a GenServer.cast/2-compatible value of the form {:noreply, new_consumer_state}. The GenConsumer will turn this into an immediate timeout, which drives continued message consumption."},{"ref":"KafkaEx.GenConsumer.html#child_spec/1","title":"KafkaEx.GenConsumer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"KafkaEx.GenConsumer.html#c:handle_call/3","title":"KafkaEx.GenConsumer.handle_call/3","type":"callback","doc":"Invoked by KafkaEx.GenConsumer.call/3. Note the default implementation will cause a RuntimeError. If you want to interact with your consumer, you must implement a handle_call function."},{"ref":"KafkaEx.GenConsumer.html#c:handle_cast/2","title":"KafkaEx.GenConsumer.handle_cast/2","type":"callback","doc":"Invoked by KafkaEx.GenConsumer.cast/2. Note the default implementation will cause a RuntimeError. If you want to interact with your consumer, you must implement a handle_cast function."},{"ref":"KafkaEx.GenConsumer.html#c:handle_info/2","title":"KafkaEx.GenConsumer.handle_info/2","type":"callback","doc":"Invoked by sending messages to the consumer. Note the default implementation will log error messages. If you want to interact with your consumer, you must implement a handle_info function."},{"ref":"KafkaEx.GenConsumer.html#c:handle_message_set/2","title":"KafkaEx.GenConsumer.handle_message_set/2","type":"callback","doc":"Invoked for each message set consumed from a Kafka topic partition. message_set is a message set fetched from a Kafka broker and state is the current state of the KafkaEx.GenConsumer. Returning {:async_commit, new_state} acknowledges message and continues to consume from the Kafka queue with new state new_state. Acknowledged messages will be auto-committed (possibly at a later time) based on the :commit_interval and :commit_threshold options. Returning {:sync_commit, new_state} commits message synchronously before continuing to consume from the Kafka queue with new state new_state. Committing a message synchronously means that no more messages will be consumed until the message&#39;s offset is committed. :sync_commit should be used sparingly, since committing every message synchronously would impact a consumer&#39;s performance and could result in excessive network traffic."},{"ref":"KafkaEx.GenConsumer.html#init/1","title":"KafkaEx.GenConsumer.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"KafkaEx.GenConsumer.html#c:init/2","title":"KafkaEx.GenConsumer.init/2","type":"callback","doc":"Invoked when the server is started. start_link/5 will block until it returns. topic and partition are the arguments passed to start_link/5. They identify the Kafka partition that the KafkaEx.GenConsumer will consume from. Returning {:ok, state} will cause start_link/5 to return {:ok, pid} and the process to start consuming from its assigned partition. state becomes the consumer&#39;s state. Any other return value will cause the start_link/5 to return {:error, error} and the process to exit."},{"ref":"KafkaEx.GenConsumer.html#c:init/3","title":"KafkaEx.GenConsumer.init/3","type":"callback","doc":"Invoked when the server is started. start_link/5 will block until it returns. topic and partition are the arguments passed to start_link/5. They identify the Kafka partition that the KafkaEx.GenConsumer will consume from. extra_args is the value of the extra_consumer_args option to start_link/5. The default implementation of this function calls init/2. Returning {:ok, state} will cause start_link/5 to return {:ok, pid} and the process to start consuming from its assigned partition. state becomes the consumer&#39;s state. Any other return value will cause the start_link/5 to return {:error, error} and the process to exit."},{"ref":"KafkaEx.GenConsumer.html#partition/2","title":"KafkaEx.GenConsumer.partition/2","type":"function","doc":"Returns the topic and partition id for this consumer process"},{"ref":"KafkaEx.GenConsumer.html#start_link/5","title":"KafkaEx.GenConsumer.start_link/5","type":"function","doc":"Starts a KafkaEx.GenConsumer process linked to the current process. This can be used to start the KafkaEx.GenConsumer as part of a supervision tree. Once the consumer has been started, the init/2 function of consumer_module is called with topic and partition as its arguments. group_name is the consumer group name that will be used for managing consumer offsets. Options :commit_interval - The interval in milliseconds that the consumer will wait to commit offsets of handled messages. Default 5_000. :commit_threshold - Threshold number of messages consumed to commit offsets to the broker. Default 100. :auto_offset_reset - The policy for resetting offsets when an :offset_out_of_range error occurs. :earliest will move the offset to the oldest available, :latest moves to the most recent. If anything else is specified, the error will simply be raised. :fetch_options - Optional keyword list that is passed along to the KafkaEx.fetch call. :extra_consumer_args - Optional parameter that is passed along to the GenConsumer.init call in the consumer module. Note that if init/3 is not implemented, the default implementation calls to init/2, dropping the extra arguments. Both :commit_interval and :commit_threshold default to the application config (e.g., Application.get_env/2) if that value is present, or the stated default if the application config is not present. Any valid options for GenServer.start_link/3 can also be specified. Return Values This function has the same return values as GenServer.start_link/3."},{"ref":"KafkaEx.GenConsumer.html#t:option/0","title":"KafkaEx.GenConsumer.option/0","type":"type","doc":"Option values used when starting a KafkaEx.GenConsumer."},{"ref":"KafkaEx.GenConsumer.html#t:options/0","title":"KafkaEx.GenConsumer.options/0","type":"type","doc":"Options used when starting a KafkaEx.GenConsumer."},{"ref":"KafkaEx.GenConsumer.Supervisor.html","title":"KafkaEx.GenConsumer.Supervisor","type":"module","doc":"A supervisor for managing GenConsumer processes that are part of a consumer group. The supervisor will launch individual GenConsumer processes for each partition given by the partitions argument to start_link/4. When terminated, each of the supervisor&#39;s child processes will commit its latest offset before terminating. This module manages a static list of consumer processes. For dynamically distributing consumers in a consumer group across a cluster of nodes, see KafkaEx.ConsumerGroup."},{"ref":"KafkaEx.GenConsumer.Supervisor.html#active?/1","title":"KafkaEx.GenConsumer.Supervisor.active?/1","type":"function","doc":"Returns true if any child pids are alive"},{"ref":"KafkaEx.GenConsumer.Supervisor.html#child_pids/1","title":"KafkaEx.GenConsumer.Supervisor.child_pids/1","type":"function","doc":"Returns a list of child pids Intended to be used for operational and testing purposes"},{"ref":"KafkaEx.GenConsumer.Supervisor.html#child_spec/1","title":"KafkaEx.GenConsumer.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"KafkaEx.GenConsumer.Supervisor.html#init/1","title":"KafkaEx.GenConsumer.Supervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"KafkaEx.GenConsumer.Supervisor.html#start_link/4","title":"KafkaEx.GenConsumer.Supervisor.start_link/4","type":"function","doc":"Starts a GenConsumer.Supervisor process linked to the current process. gen_consumer_module is a module that implements the GenServer behaviour which consumes events from kafka. consumer_module is a module that implements the GenConsumer behaviour. group_name is the name of a consumer group, and assignments is a list of partitions for the GenConsumers to consume. opts accepts the same options as KafkaEx.GenConsumer.start_link/5. Return Values This function has the same return values as Supervisor.start_link/3. If the supervisor and its consumers are successfully created, this function returns {:ok, pid}, where pid is the PID of the supervisor."},{"ref":"KafkaEx.InvalidConsumerGroupError.html","title":"KafkaEx.InvalidConsumerGroupError","type":"exception","doc":""},{"ref":"KafkaEx.LegacyPartitioner.html","title":"KafkaEx.LegacyPartitioner","type":"module","doc":"Legacy default partitioner implementation. This &quot;legacy partitioner&quot; used to be the default partitioner for KafkaEx when a message key is set and a partition isn&#39;t. This was intended to match the behaviour of the default Java client, however there was some small differences. This legacy partitioner keeps the previous behaviour, and the current default partitioner now correctly matches the Java client."},{"ref":"KafkaEx.LegacyPartitioner.html#assign_partition/2","title":"KafkaEx.LegacyPartitioner.assign_partition/2","type":"function","doc":"Callback implementation for KafkaEx.Partitioner.assign_partition/2."},{"ref":"KafkaEx.New.Broker.html","title":"KafkaEx.New.Broker","type":"module","doc":"Encapsulates what we know about a broker"},{"ref":"KafkaEx.New.Broker.html#has_socket?/2","title":"KafkaEx.New.Broker.has_socket?/2","type":"function","doc":""},{"ref":"KafkaEx.New.Broker.html#t:t/0","title":"KafkaEx.New.Broker.t/0","type":"type","doc":""},{"ref":"KafkaEx.New.Client.html","title":"KafkaEx.New.Client","type":"module","doc":"Kayrock-compatible KafkaEx.Server implementation This implementation attempts to keep as much Kafka &#39;business logic&#39; as possible out of the server implementation, with the motivation that this should make the client easier to maintain as the Kafka protocol evolves. This implementation does, however, include implementations of all of the legacy KafkaEx.Server handle_call clauses so that it can be compatible with the legacy KafkaEx API."},{"ref":"KafkaEx.New.Client.html#child_spec/1","title":"KafkaEx.New.Client.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"KafkaEx.New.Client.html#send_request/4","title":"KafkaEx.New.Client.send_request/4","type":"function","doc":"Send a Kayrock request to the appropriate broker Broker metadata will be updated if necessary"},{"ref":"KafkaEx.New.Client.html#start_link/2","title":"KafkaEx.New.Client.start_link/2","type":"function","doc":"Start the server in a supervision tree"},{"ref":"KafkaEx.New.Client.html#t:args/0","title":"KafkaEx.New.Client.args/0","type":"type","doc":""},{"ref":"KafkaEx.New.ClusterMetadata.html","title":"KafkaEx.New.ClusterMetadata","type":"module","doc":"Encapsulates what we know about the state of a Kafka broker cluster This module is mainly used internally in New.Client, but some of its functions may be useful for extracting metadata information"},{"ref":"KafkaEx.New.ClusterMetadata.html#broker_by_node_id/2","title":"KafkaEx.New.ClusterMetadata.broker_by_node_id/2","type":"function","doc":"Returns a t:Broker.t/0 for the given t:KafkaExAPI.node_id/0 or nil if there is no known broker with that node id"},{"ref":"KafkaEx.New.ClusterMetadata.html#brokers/1","title":"KafkaEx.New.ClusterMetadata.brokers/1","type":"function","doc":"Return a list of the known brokers"},{"ref":"KafkaEx.New.ClusterMetadata.html#from_metadata_v1_response/1","title":"KafkaEx.New.ClusterMetadata.from_metadata_v1_response/1","type":"function","doc":"Constructs a t/0 from a Kayrock.Metadata.V1.Response struct. The V1 here is a minimum - this should work with higher versions of the metadata response struct."},{"ref":"KafkaEx.New.ClusterMetadata.html#known_topics/1","title":"KafkaEx.New.ClusterMetadata.known_topics/1","type":"function","doc":"List names of topics known by the cluster metadata NOTE this is a subset of the topics in the cluster - it will only contain topics for which we have fetched metadata"},{"ref":"KafkaEx.New.ClusterMetadata.html#select_node/2","title":"KafkaEx.New.ClusterMetadata.select_node/2","type":"function","doc":"Find the node id for a given selector Note this will not update the metadata, only select a node given the current metadata. See KafkaEx.New.NodeSelector.t/0"},{"ref":"KafkaEx.New.ClusterMetadata.html#topics_metadata/2","title":"KafkaEx.New.ClusterMetadata.topics_metadata/2","type":"function","doc":"Return the metadata for the given topics"},{"ref":"KafkaEx.New.ClusterMetadata.html#t:node_select_error/0","title":"KafkaEx.New.ClusterMetadata.node_select_error/0","type":"type","doc":"Possible errors given by select_node/2"},{"ref":"KafkaEx.New.ClusterMetadata.html#t:t/0","title":"KafkaEx.New.ClusterMetadata.t/0","type":"type","doc":""},{"ref":"KafkaEx.New.KafkaExAPI.html","title":"KafkaEx.New.KafkaExAPI","type":"module","doc":"This module interfaces Kafka through the New.Client implementation This is intended to become the future KafkaEx API Most functions here take a client pid as the first argument. {:ok, client} = KafkaEx.New.Client.start_link() KafkaEx.New.KafkaExAPI.latest_offset(client, &quot;some_topic&quot;, 0)"},{"ref":"KafkaEx.New.KafkaExAPI.html#cluster_metadata/1","title":"KafkaEx.New.KafkaExAPI.cluster_metadata/1","type":"function","doc":"Returns the cluster metadata from the given client"},{"ref":"KafkaEx.New.KafkaExAPI.html#correlation_id/1","title":"KafkaEx.New.KafkaExAPI.correlation_id/1","type":"function","doc":"Returns the current correlation id for the given client"},{"ref":"KafkaEx.New.KafkaExAPI.html#latest_offset/3","title":"KafkaEx.New.KafkaExAPI.latest_offset/3","type":"function","doc":"Fetch the latest offset for a given partition"},{"ref":"KafkaEx.New.KafkaExAPI.html#set_consumer_group_for_auto_commit/2","title":"KafkaEx.New.KafkaExAPI.set_consumer_group_for_auto_commit/2","type":"function","doc":"Set the consumer group name that will be used by the given client for autocommit NOTE this function will not be supported after the legacy API is removed"},{"ref":"KafkaEx.New.KafkaExAPI.html#topics_metadata/3","title":"KafkaEx.New.KafkaExAPI.topics_metadata/3","type":"function","doc":"Get topic metadata for the given topics Always calls out to the broker to get the most up-to-date metadata (and subsequently updates the client&#39;s state with the updated metadata). Set allow_topic_creation to true to allow the topics to be created if they don&#39;t exist"},{"ref":"KafkaEx.New.KafkaExAPI.html#t:client/0","title":"KafkaEx.New.KafkaExAPI.client/0","type":"type","doc":""},{"ref":"KafkaEx.New.KafkaExAPI.html#t:consumer_group_name/0","title":"KafkaEx.New.KafkaExAPI.consumer_group_name/0","type":"type","doc":""},{"ref":"KafkaEx.New.KafkaExAPI.html#t:correlation_id/0","title":"KafkaEx.New.KafkaExAPI.correlation_id/0","type":"type","doc":""},{"ref":"KafkaEx.New.KafkaExAPI.html#t:error_atom/0","title":"KafkaEx.New.KafkaExAPI.error_atom/0","type":"type","doc":""},{"ref":"KafkaEx.New.KafkaExAPI.html#t:node_id/0","title":"KafkaEx.New.KafkaExAPI.node_id/0","type":"type","doc":""},{"ref":"KafkaEx.New.KafkaExAPI.html#t:offset/0","title":"KafkaEx.New.KafkaExAPI.offset/0","type":"type","doc":""},{"ref":"KafkaEx.New.KafkaExAPI.html#t:partition_id/0","title":"KafkaEx.New.KafkaExAPI.partition_id/0","type":"type","doc":""},{"ref":"KafkaEx.New.KafkaExAPI.html#t:topic_name/0","title":"KafkaEx.New.KafkaExAPI.topic_name/0","type":"type","doc":""},{"ref":"KafkaEx.New.NodeSelector.html","title":"KafkaEx.New.NodeSelector","type":"module","doc":"Defines node selector functions and macros"},{"ref":"KafkaEx.New.NodeSelector.html#consumer_group/1","title":"KafkaEx.New.NodeSelector.consumer_group/1","type":"function","doc":"Select the controller for the given consumer group"},{"ref":"KafkaEx.New.NodeSelector.html#controller/0","title":"KafkaEx.New.NodeSelector.controller/0","type":"function","doc":"Select the cluster&#39;s controller node"},{"ref":"KafkaEx.New.NodeSelector.html#first_available/0","title":"KafkaEx.New.NodeSelector.first_available/0","type":"function","doc":"Select first available node"},{"ref":"KafkaEx.New.NodeSelector.html#node_id/1","title":"KafkaEx.New.NodeSelector.node_id/1","type":"function","doc":"Select a specific node"},{"ref":"KafkaEx.New.NodeSelector.html#random/0","title":"KafkaEx.New.NodeSelector.random/0","type":"function","doc":"Select a random node"},{"ref":"KafkaEx.New.NodeSelector.html#topic_partition/2","title":"KafkaEx.New.NodeSelector.topic_partition/2","type":"function","doc":"Select the controller for the given topic and partition"},{"ref":"KafkaEx.New.NodeSelector.html#t:t/0","title":"KafkaEx.New.NodeSelector.t/0","type":"type","doc":""},{"ref":"KafkaEx.New.Partition.html","title":"KafkaEx.New.Partition","type":"module","doc":"Encapsulates what we know about a partition"},{"ref":"KafkaEx.New.Partition.html#t:t/0","title":"KafkaEx.New.Partition.t/0","type":"type","doc":""},{"ref":"KafkaEx.New.Topic.html","title":"KafkaEx.New.Topic","type":"module","doc":"Encapsulates what we know about a topic"},{"ref":"KafkaEx.New.Topic.html#t:t/0","title":"KafkaEx.New.Topic.t/0","type":"type","doc":""},{"ref":"KafkaEx.Partitioner.html","title":"KafkaEx.Partitioner","type":"behaviour","doc":"Behaviour definition for partitioners, that assigns partitions for requests."},{"ref":"KafkaEx.Partitioner.html#c:assign_partition/2","title":"KafkaEx.Partitioner.assign_partition/2","type":"callback","doc":""},{"ref":"KafkaEx.Partitioner.html#get_key/1","title":"KafkaEx.Partitioner.get_key/1","type":"function","doc":"Returns key for given messages Function looks for message key in messages list of {ProduceRequest}. It may return either {:ok, nil} if no key was found, {:ok, key} when key was found, or {:error, atom} when error happens while looking for the key."},{"ref":"KafkaEx.Protocol.ApiVersions.html","title":"KafkaEx.Protocol.ApiVersions","type":"module","doc":"Implementation of the Kafka ApiVersions request and response APIs See: https://kafka.apache.org/protocol.html#The_Messages_ApiVersions Reference implementation in Java: https://github.com/apache/kafka/blob/trunk/clients/src/main/java/org/apache/kafka/common/requests/ApiVersionsRequest.java https://github.com/apache/kafka/blob/trunk/clients/src/main/java/org/apache/kafka/common/requests/ApiVersionsResponse.java"},{"ref":"KafkaEx.Protocol.ApiVersions.html#create_request/3","title":"KafkaEx.Protocol.ApiVersions.create_request/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.ApiVersions.html#parse_response/2","title":"KafkaEx.Protocol.ApiVersions.parse_response/2","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Common.html","title":"KafkaEx.Protocol.Common","type":"module","doc":"A collection of common request generation and response parsing functions for the Kafka wire protocol."},{"ref":"KafkaEx.Protocol.Common.html#encode_nullable_string/1","title":"KafkaEx.Protocol.Common.encode_nullable_string/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Common.html#encode_string/1","title":"KafkaEx.Protocol.Common.encode_string/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Common.html#map_encode/2","title":"KafkaEx.Protocol.Common.map_encode/2","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Common.html#parse_topics/3","title":"KafkaEx.Protocol.Common.parse_topics/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Common.html#read_array/3","title":"KafkaEx.Protocol.Common.read_array/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Common.html#topic_data/1","title":"KafkaEx.Protocol.Common.topic_data/1","type":"function","doc":"Generate the wire representation for a list of topics."},{"ref":"KafkaEx.Protocol.ConsumerMetadata.html","title":"KafkaEx.Protocol.ConsumerMetadata","type":"module","doc":"Implementation of the Kafka ConsumerMetadata request and response APIs"},{"ref":"KafkaEx.Protocol.ConsumerMetadata.html#create_request/3","title":"KafkaEx.Protocol.ConsumerMetadata.create_request/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.ConsumerMetadata.html#parse_response/1","title":"KafkaEx.Protocol.ConsumerMetadata.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.CreateTopics.html","title":"KafkaEx.Protocol.CreateTopics","type":"module","doc":"Implementation of the Kafka CreateTopics request and response APIs See: https://kafka.apache.org/protocol.html#The_Messages_CreateTopics"},{"ref":"KafkaEx.Protocol.CreateTopics.html#api_version/1","title":"KafkaEx.Protocol.CreateTopics.api_version/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.CreateTopics.html#create_request/4","title":"KafkaEx.Protocol.CreateTopics.create_request/4","type":"function","doc":""},{"ref":"KafkaEx.Protocol.CreateTopics.html#parse_response/2","title":"KafkaEx.Protocol.CreateTopics.parse_response/2","type":"function","doc":""},{"ref":"KafkaEx.Protocol.DeleteTopics.html","title":"KafkaEx.Protocol.DeleteTopics","type":"module","doc":"Implementation of the Kafka DeleteTopics request and response APIs See: https://kafka.apache.org/protocol.html#The_Messages_DeleteTopics"},{"ref":"KafkaEx.Protocol.DeleteTopics.html#api_version/1","title":"KafkaEx.Protocol.DeleteTopics.api_version/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.DeleteTopics.html#create_request/4","title":"KafkaEx.Protocol.DeleteTopics.create_request/4","type":"function","doc":""},{"ref":"KafkaEx.Protocol.DeleteTopics.html#parse_response/2","title":"KafkaEx.Protocol.DeleteTopics.parse_response/2","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Fetch.html","title":"KafkaEx.Protocol.Fetch","type":"module","doc":"Implementation of the Kafka Fetch request and response APIs"},{"ref":"KafkaEx.Protocol.Fetch.html#create_request/1","title":"KafkaEx.Protocol.Fetch.create_request/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Fetch.html#parse_partitions/4","title":"KafkaEx.Protocol.Fetch.parse_partitions/4","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Fetch.html#parse_response/1","title":"KafkaEx.Protocol.Fetch.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Heartbeat.html","title":"KafkaEx.Protocol.Heartbeat","type":"module","doc":"Implementation of the Kafka Hearbeat request and response APIs"},{"ref":"KafkaEx.Protocol.Heartbeat.html#create_request/3","title":"KafkaEx.Protocol.Heartbeat.create_request/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Heartbeat.html#parse_response/1","title":"KafkaEx.Protocol.Heartbeat.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.JoinGroup.html","title":"KafkaEx.Protocol.JoinGroup","type":"module","doc":"Implementation of the Kafka JoinGroup request and response APIs"},{"ref":"KafkaEx.Protocol.JoinGroup.html#create_request/3","title":"KafkaEx.Protocol.JoinGroup.create_request/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.JoinGroup.html#parse_response/1","title":"KafkaEx.Protocol.JoinGroup.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.LeaveGroup.html","title":"KafkaEx.Protocol.LeaveGroup","type":"module","doc":""},{"ref":"KafkaEx.Protocol.LeaveGroup.html#create_request/3","title":"KafkaEx.Protocol.LeaveGroup.create_request/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.LeaveGroup.html#parse_response/1","title":"KafkaEx.Protocol.LeaveGroup.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Metadata.html","title":"KafkaEx.Protocol.Metadata","type":"module","doc":"Implementation of the Kafka Hearbeat request and response APIs"},{"ref":"KafkaEx.Protocol.Metadata.html#api_version/1","title":"KafkaEx.Protocol.Metadata.api_version/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Metadata.html#create_request/4","title":"KafkaEx.Protocol.Metadata.create_request/4","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Metadata.html#parse_response/1","title":"KafkaEx.Protocol.Metadata.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Metadata.html#parse_response/2","title":"KafkaEx.Protocol.Metadata.parse_response/2","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Offset.html","title":"KafkaEx.Protocol.Offset","type":"module","doc":"Implementation of the Kafka Offset request and response APIs"},{"ref":"KafkaEx.Protocol.Offset.html#create_request/5","title":"KafkaEx.Protocol.Offset.create_request/5","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Offset.html#parse_response/1","title":"KafkaEx.Protocol.Offset.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Offset.html#parse_time/1","title":"KafkaEx.Protocol.Offset.parse_time/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.OffsetCommit.html","title":"KafkaEx.Protocol.OffsetCommit","type":"module","doc":"Implementation of the Kafka OffsetCommit request and response APIs"},{"ref":"KafkaEx.Protocol.OffsetCommit.html#create_request/3","title":"KafkaEx.Protocol.OffsetCommit.create_request/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.OffsetCommit.html#parse_response/1","title":"KafkaEx.Protocol.OffsetCommit.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.OffsetFetch.html","title":"KafkaEx.Protocol.OffsetFetch","type":"module","doc":"Implementation of the Kafka OffsetFetch request and response APIs"},{"ref":"KafkaEx.Protocol.OffsetFetch.html#create_request/3","title":"KafkaEx.Protocol.OffsetFetch.create_request/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.OffsetFetch.html#parse_partitions/4","title":"KafkaEx.Protocol.OffsetFetch.parse_partitions/4","type":"function","doc":""},{"ref":"KafkaEx.Protocol.OffsetFetch.html#parse_response/1","title":"KafkaEx.Protocol.OffsetFetch.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Produce.html","title":"KafkaEx.Protocol.Produce","type":"module","doc":"Implementation of the Kafka Produce request and response APIs"},{"ref":"KafkaEx.Protocol.Produce.html#create_request/3","title":"KafkaEx.Protocol.Produce.create_request/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Produce.html#parse_partitions/4","title":"KafkaEx.Protocol.Produce.parse_partitions/4","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Produce.html#parse_response/1","title":"KafkaEx.Protocol.Produce.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Protocol.Produce.Message.html","title":"KafkaEx.Protocol.Produce.Message","type":"module","doc":"key: is used for partition assignment, can be nil, when none is provided it is defaulted to nil value: is the message to be written to kafka logs. timestamp: timestamp (kafka_version: &quot;kayrock&quot; ONLY)"},{"ref":"KafkaEx.Protocol.Produce.Message.html#t:t/0","title":"KafkaEx.Protocol.Produce.Message.t/0","type":"type","doc":""},{"ref":"KafkaEx.Protocol.Produce.Request.html","title":"KafkaEx.Protocol.Produce.Request","type":"module","doc":"required_acks: indicates how many acknowledgements the servers should receive before responding to the request. If it is 0 the server will not send any response (this is the only case where the server will not reply to a request). If it is 1, the server will wait the data is written to the local log before sending a response. If it is -1 the server will block until the message is committed by all in sync replicas before sending a response. For any number &gt; 1 the server will block waiting for this number of acknowledgements to occur (but the server will never wait for more acknowledgements than there are in-sync replicas), default is 0 timeout: provides a maximum time in milliseconds the server can await the receipt of the number of acknowledgements in RequiredAcks, default is 100 milliseconds"},{"ref":"KafkaEx.Protocol.Produce.Request.html#t:t/0","title":"KafkaEx.Protocol.Produce.Request.t/0","type":"type","doc":""},{"ref":"KafkaEx.Protocol.SyncGroup.html","title":"KafkaEx.Protocol.SyncGroup","type":"module","doc":"Implementation of the Kafka SyncGroup request and response APIs"},{"ref":"KafkaEx.Protocol.SyncGroup.html#create_request/3","title":"KafkaEx.Protocol.SyncGroup.create_request/3","type":"function","doc":""},{"ref":"KafkaEx.Protocol.SyncGroup.html#parse_response/1","title":"KafkaEx.Protocol.SyncGroup.parse_response/1","type":"function","doc":""},{"ref":"KafkaEx.Server.html","title":"KafkaEx.Server","type":"behaviour","doc":"Defines the KafkaEx.Server behavior that all Kafka API servers must implement, this module also provides some common callback functions that are injected into the servers that use it."},{"ref":"KafkaEx.Server.html#c:kafka_server_api_versions/1","title":"KafkaEx.Server.kafka_server_api_versions/1","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_consumer_group/1","title":"KafkaEx.Server.kafka_server_consumer_group/1","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_consumer_group_metadata/1","title":"KafkaEx.Server.kafka_server_consumer_group_metadata/1","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_create_topics/3","title":"KafkaEx.Server.kafka_server_create_topics/3","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_delete_topics/3","title":"KafkaEx.Server.kafka_server_delete_topics/3","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_fetch/2","title":"KafkaEx.Server.kafka_server_fetch/2","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_heartbeat/3","title":"KafkaEx.Server.kafka_server_heartbeat/3","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_init/1","title":"KafkaEx.Server.kafka_server_init/1","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_join_group/3","title":"KafkaEx.Server.kafka_server_join_group/3","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_leave_group/3","title":"KafkaEx.Server.kafka_server_leave_group/3","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_metadata/2","title":"KafkaEx.Server.kafka_server_metadata/2","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_offset/4","title":"KafkaEx.Server.kafka_server_offset/4","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_offset_commit/2","title":"KafkaEx.Server.kafka_server_offset_commit/2","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_offset_fetch/2","title":"KafkaEx.Server.kafka_server_offset_fetch/2","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_produce/2","title":"KafkaEx.Server.kafka_server_produce/2","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_sync_group/3","title":"KafkaEx.Server.kafka_server_sync_group/3","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_update_consumer_metadata/1","title":"KafkaEx.Server.kafka_server_update_consumer_metadata/1","type":"callback","doc":""},{"ref":"KafkaEx.Server.html#c:kafka_server_update_metadata/1","title":"KafkaEx.Server.kafka_server_update_metadata/1","type":"callback","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html","title":"KafkaEx.Server0P10AndLater","type":"module","doc":"Implements kafkaEx.Server behaviors for kafka 0.10.1 API."},{"ref":"KafkaEx.Server0P10AndLater.html#broker_for_consumer_group_with_update/2","title":"KafkaEx.Server0P10AndLater.broker_for_consumer_group_with_update/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html#consumer_group?/1","title":"KafkaEx.Server0P10AndLater.consumer_group?/1","type":"function","doc":"See KafkaEx.Server0P9P0.consumer_group?/1."},{"ref":"KafkaEx.Server0P10AndLater.html#handle_call/3","title":"KafkaEx.Server0P10AndLater.handle_call/3","type":"function","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html#handle_info/2","title":"KafkaEx.Server0P10AndLater.handle_info/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html#init/1","title":"KafkaEx.Server0P10AndLater.init/1","type":"function","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_api_versions/1","title":"KafkaEx.Server0P10AndLater.kafka_server_api_versions/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_api_versions/1."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_consumer_group/1","title":"KafkaEx.Server0P10AndLater.kafka_server_consumer_group/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_consumer_group/1."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_consumer_group_metadata/1","title":"KafkaEx.Server0P10AndLater.kafka_server_consumer_group_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_consumer_group_metadata/1."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_create_topics/3","title":"KafkaEx.Server0P10AndLater.kafka_server_create_topics/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_create_topics/3."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_delete_topics/3","title":"KafkaEx.Server0P10AndLater.kafka_server_delete_topics/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_delete_topics/3."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_fetch/2","title":"KafkaEx.Server0P10AndLater.kafka_server_fetch/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_fetch/2."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_heartbeat/3","title":"KafkaEx.Server0P10AndLater.kafka_server_heartbeat/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_heartbeat/3."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_init/1","title":"KafkaEx.Server0P10AndLater.kafka_server_init/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_init/1."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_join_group/3","title":"KafkaEx.Server0P10AndLater.kafka_server_join_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_join_group/3."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_leave_group/3","title":"KafkaEx.Server0P10AndLater.kafka_server_leave_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_leave_group/3."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_metadata/2","title":"KafkaEx.Server0P10AndLater.kafka_server_metadata/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_metadata/2."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_offset/4","title":"KafkaEx.Server0P10AndLater.kafka_server_offset/4","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset/4."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_offset_commit/2","title":"KafkaEx.Server0P10AndLater.kafka_server_offset_commit/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset_commit/2."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_offset_fetch/2","title":"KafkaEx.Server0P10AndLater.kafka_server_offset_fetch/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset_fetch/2."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_produce/2","title":"KafkaEx.Server0P10AndLater.kafka_server_produce/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_produce/2."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_produce_send_request/4","title":"KafkaEx.Server0P10AndLater.kafka_server_produce_send_request/4","type":"function","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_sync_group/3","title":"KafkaEx.Server0P10AndLater.kafka_server_sync_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_sync_group/3."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_update_consumer_metadata/1","title":"KafkaEx.Server0P10AndLater.kafka_server_update_consumer_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_update_consumer_metadata/1."},{"ref":"KafkaEx.Server0P10AndLater.html#kafka_server_update_metadata/1","title":"KafkaEx.Server0P10AndLater.kafka_server_update_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_update_metadata/1."},{"ref":"KafkaEx.Server0P10AndLater.html#retrieve_metadata/5","title":"KafkaEx.Server0P10AndLater.retrieve_metadata/5","type":"function","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html#retrieve_metadata/7","title":"KafkaEx.Server0P10AndLater.retrieve_metadata/7","type":"function","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html#retrieve_metadata_with_version/7","title":"KafkaEx.Server0P10AndLater.retrieve_metadata_with_version/7","type":"function","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html#start_link/2","title":"KafkaEx.Server0P10AndLater.start_link/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html#terminate/2","title":"KafkaEx.Server0P10AndLater.terminate/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P10AndLater.html#update_consumer_metadata/3","title":"KafkaEx.Server0P10AndLater.update_consumer_metadata/3","type":"function","doc":"See KafkaEx.Server0P8P2.update_consumer_metadata/3."},{"ref":"KafkaEx.Server0P10AndLater.html#update_metadata/1","title":"KafkaEx.Server0P10AndLater.update_metadata/1","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P0.html","title":"KafkaEx.Server0P8P0","type":"module","doc":"Implements kafkaEx.Server behaviors for kafka &gt;= 0.8.0 &lt; 0.8.2 API."},{"ref":"KafkaEx.Server0P8P0.html#handle_call/3","title":"KafkaEx.Server0P8P0.handle_call/3","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P0.html#handle_info/2","title":"KafkaEx.Server0P8P0.handle_info/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P0.html#init/1","title":"KafkaEx.Server0P8P0.init/1","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_api_versions/1","title":"KafkaEx.Server0P8P0.kafka_server_api_versions/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_api_versions/1."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_consumer_group/1","title":"KafkaEx.Server0P8P0.kafka_server_consumer_group/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_consumer_group/1."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_consumer_group_metadata/1","title":"KafkaEx.Server0P8P0.kafka_server_consumer_group_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_consumer_group_metadata/1."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_create_topics/3","title":"KafkaEx.Server0P8P0.kafka_server_create_topics/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_create_topics/3."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_delete_topics/3","title":"KafkaEx.Server0P8P0.kafka_server_delete_topics/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_delete_topics/3."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_fetch/2","title":"KafkaEx.Server0P8P0.kafka_server_fetch/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_fetch/2."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_heartbeat/3","title":"KafkaEx.Server0P8P0.kafka_server_heartbeat/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_heartbeat/3."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_init/1","title":"KafkaEx.Server0P8P0.kafka_server_init/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_init/1."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_join_group/3","title":"KafkaEx.Server0P8P0.kafka_server_join_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_join_group/3."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_leave_group/3","title":"KafkaEx.Server0P8P0.kafka_server_leave_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_leave_group/3."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_metadata/2","title":"KafkaEx.Server0P8P0.kafka_server_metadata/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_metadata/2."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_offset/4","title":"KafkaEx.Server0P8P0.kafka_server_offset/4","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset/4."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_offset_commit/2","title":"KafkaEx.Server0P8P0.kafka_server_offset_commit/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset_commit/2."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_offset_fetch/2","title":"KafkaEx.Server0P8P0.kafka_server_offset_fetch/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset_fetch/2."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_produce/2","title":"KafkaEx.Server0P8P0.kafka_server_produce/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_produce/2."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_produce_send_request/4","title":"KafkaEx.Server0P8P0.kafka_server_produce_send_request/4","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_sync_group/3","title":"KafkaEx.Server0P8P0.kafka_server_sync_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_sync_group/3."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_update_consumer_metadata/1","title":"KafkaEx.Server0P8P0.kafka_server_update_consumer_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_update_consumer_metadata/1."},{"ref":"KafkaEx.Server0P8P0.html#kafka_server_update_metadata/1","title":"KafkaEx.Server0P8P0.kafka_server_update_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_update_metadata/1."},{"ref":"KafkaEx.Server0P8P0.html#retrieve_metadata/5","title":"KafkaEx.Server0P8P0.retrieve_metadata/5","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P0.html#retrieve_metadata/7","title":"KafkaEx.Server0P8P0.retrieve_metadata/7","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P0.html#retrieve_metadata_with_version/7","title":"KafkaEx.Server0P8P0.retrieve_metadata_with_version/7","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P0.html#start_link/2","title":"KafkaEx.Server0P8P0.start_link/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P0.html#terminate/2","title":"KafkaEx.Server0P8P0.terminate/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P0.html#update_metadata/1","title":"KafkaEx.Server0P8P0.update_metadata/1","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html","title":"KafkaEx.Server0P8P2","type":"module","doc":"Implements kafkaEx.Server behaviors for kafka &gt;= 0.8.2 &lt; 0.9.0 API."},{"ref":"KafkaEx.Server0P8P2.html#consumer_group?/1","title":"KafkaEx.Server0P8P2.consumer_group?/1","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#consumer_group_if_auto_commit?/2","title":"KafkaEx.Server0P8P2.consumer_group_if_auto_commit?/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#handle_call/3","title":"KafkaEx.Server0P8P2.handle_call/3","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#handle_info/2","title":"KafkaEx.Server0P8P2.handle_info/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#init/1","title":"KafkaEx.Server0P8P2.init/1","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_api_versions/1","title":"KafkaEx.Server0P8P2.kafka_server_api_versions/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_api_versions/1."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_consumer_group/1","title":"KafkaEx.Server0P8P2.kafka_server_consumer_group/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_consumer_group/1."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_consumer_group_metadata/1","title":"KafkaEx.Server0P8P2.kafka_server_consumer_group_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_consumer_group_metadata/1."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_create_topics/3","title":"KafkaEx.Server0P8P2.kafka_server_create_topics/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_create_topics/3."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_delete_topics/3","title":"KafkaEx.Server0P8P2.kafka_server_delete_topics/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_delete_topics/3."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_fetch/2","title":"KafkaEx.Server0P8P2.kafka_server_fetch/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_fetch/2."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_heartbeat/3","title":"KafkaEx.Server0P8P2.kafka_server_heartbeat/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_heartbeat/3."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_init/1","title":"KafkaEx.Server0P8P2.kafka_server_init/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_init/1."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_join_group/3","title":"KafkaEx.Server0P8P2.kafka_server_join_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_join_group/3."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_leave_group/3","title":"KafkaEx.Server0P8P2.kafka_server_leave_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_leave_group/3."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_metadata/2","title":"KafkaEx.Server0P8P2.kafka_server_metadata/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_metadata/2."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_offset/4","title":"KafkaEx.Server0P8P2.kafka_server_offset/4","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset/4."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_offset_commit/2","title":"KafkaEx.Server0P8P2.kafka_server_offset_commit/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset_commit/2."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_offset_fetch/2","title":"KafkaEx.Server0P8P2.kafka_server_offset_fetch/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset_fetch/2."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_produce/2","title":"KafkaEx.Server0P8P2.kafka_server_produce/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_produce/2."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_produce_send_request/4","title":"KafkaEx.Server0P8P2.kafka_server_produce_send_request/4","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_sync_group/3","title":"KafkaEx.Server0P8P2.kafka_server_sync_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_sync_group/3."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_update_consumer_metadata/1","title":"KafkaEx.Server0P8P2.kafka_server_update_consumer_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_update_consumer_metadata/1."},{"ref":"KafkaEx.Server0P8P2.html#kafka_server_update_metadata/1","title":"KafkaEx.Server0P8P2.kafka_server_update_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_update_metadata/1."},{"ref":"KafkaEx.Server0P8P2.html#retrieve_metadata/5","title":"KafkaEx.Server0P8P2.retrieve_metadata/5","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#retrieve_metadata/7","title":"KafkaEx.Server0P8P2.retrieve_metadata/7","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#retrieve_metadata_with_version/7","title":"KafkaEx.Server0P8P2.retrieve_metadata_with_version/7","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#start_link/2","title":"KafkaEx.Server0P8P2.start_link/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#terminate/2","title":"KafkaEx.Server0P8P2.terminate/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#update_consumer_metadata/3","title":"KafkaEx.Server0P8P2.update_consumer_metadata/3","type":"function","doc":""},{"ref":"KafkaEx.Server0P8P2.html#update_metadata/1","title":"KafkaEx.Server0P8P2.update_metadata/1","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html","title":"KafkaEx.Server0P9P0","type":"module","doc":"Implements kafkaEx.Server behaviors for kafka &gt;= 0.9.0 &lt; 0.10.1 API."},{"ref":"KafkaEx.Server0P9P0.html#broker_for_consumer_group_with_update/2","title":"KafkaEx.Server0P9P0.broker_for_consumer_group_with_update/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#consumer_group?/1","title":"KafkaEx.Server0P9P0.consumer_group?/1","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#handle_call/3","title":"KafkaEx.Server0P9P0.handle_call/3","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#handle_info/2","title":"KafkaEx.Server0P9P0.handle_info/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#init/1","title":"KafkaEx.Server0P9P0.init/1","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_api_versions/1","title":"KafkaEx.Server0P9P0.kafka_server_api_versions/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_api_versions/1."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_consumer_group/1","title":"KafkaEx.Server0P9P0.kafka_server_consumer_group/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_consumer_group/1."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_consumer_group_metadata/1","title":"KafkaEx.Server0P9P0.kafka_server_consumer_group_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_consumer_group_metadata/1."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_create_topics/3","title":"KafkaEx.Server0P9P0.kafka_server_create_topics/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_create_topics/3."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_delete_topics/3","title":"KafkaEx.Server0P9P0.kafka_server_delete_topics/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_delete_topics/3."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_fetch/2","title":"KafkaEx.Server0P9P0.kafka_server_fetch/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_fetch/2."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_heartbeat/3","title":"KafkaEx.Server0P9P0.kafka_server_heartbeat/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_heartbeat/3."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_init/1","title":"KafkaEx.Server0P9P0.kafka_server_init/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_init/1."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_join_group/3","title":"KafkaEx.Server0P9P0.kafka_server_join_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_join_group/3."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_leave_group/3","title":"KafkaEx.Server0P9P0.kafka_server_leave_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_leave_group/3."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_metadata/2","title":"KafkaEx.Server0P9P0.kafka_server_metadata/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_metadata/2."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_offset/4","title":"KafkaEx.Server0P9P0.kafka_server_offset/4","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset/4."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_offset_commit/2","title":"KafkaEx.Server0P9P0.kafka_server_offset_commit/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset_commit/2."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_offset_fetch/2","title":"KafkaEx.Server0P9P0.kafka_server_offset_fetch/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_offset_fetch/2."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_produce/2","title":"KafkaEx.Server0P9P0.kafka_server_produce/2","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_produce/2."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_produce_send_request/4","title":"KafkaEx.Server0P9P0.kafka_server_produce_send_request/4","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_sync_group/3","title":"KafkaEx.Server0P9P0.kafka_server_sync_group/3","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_sync_group/3."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_update_consumer_metadata/1","title":"KafkaEx.Server0P9P0.kafka_server_update_consumer_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_update_consumer_metadata/1."},{"ref":"KafkaEx.Server0P9P0.html#kafka_server_update_metadata/1","title":"KafkaEx.Server0P9P0.kafka_server_update_metadata/1","type":"function","doc":"Callback implementation for KafkaEx.Server.kafka_server_update_metadata/1."},{"ref":"KafkaEx.Server0P9P0.html#retrieve_metadata/5","title":"KafkaEx.Server0P9P0.retrieve_metadata/5","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#retrieve_metadata/7","title":"KafkaEx.Server0P9P0.retrieve_metadata/7","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#retrieve_metadata_with_version/7","title":"KafkaEx.Server0P9P0.retrieve_metadata_with_version/7","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#start_link/2","title":"KafkaEx.Server0P9P0.start_link/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#terminate/2","title":"KafkaEx.Server0P9P0.terminate/2","type":"function","doc":""},{"ref":"KafkaEx.Server0P9P0.html#update_consumer_metadata/3","title":"KafkaEx.Server0P9P0.update_consumer_metadata/3","type":"function","doc":"See KafkaEx.Server0P8P2.update_consumer_metadata/3."},{"ref":"KafkaEx.Server0P9P0.html#update_metadata/1","title":"KafkaEx.Server0P9P0.update_metadata/1","type":"function","doc":""},{"ref":"KafkaEx.Socket.html","title":"KafkaEx.Socket","type":"module","doc":"This module handle all socket related operations."},{"ref":"KafkaEx.Socket.html#close/1","title":"KafkaEx.Socket.close/1","type":"function","doc":"Closes the socket. For more information, see :ssl.close/1 for ssl or :gen_tcp.send/1 for non ssl."},{"ref":"KafkaEx.Socket.html#create/4","title":"KafkaEx.Socket.create/4","type":"function","doc":"Creates a socket. For more information about the available options, see :ssl.connect/3 for ssl or :gen_tcp.connect/3 for non ssl."},{"ref":"KafkaEx.Socket.html#info/1","title":"KafkaEx.Socket.info/1","type":"function","doc":"Returns the information about the socket. For more information, see Port.info"},{"ref":"KafkaEx.Socket.html#open?/1","title":"KafkaEx.Socket.open?/1","type":"function","doc":"Returns true if the socket is open"},{"ref":"KafkaEx.Socket.html#recv/2","title":"KafkaEx.Socket.recv/2","type":"function","doc":"Receives data from the socket. For more information, see :ssl.recv/2 for ssl or :gen_tcp.recv/2 for non ssl."},{"ref":"KafkaEx.Socket.html#recv/3","title":"KafkaEx.Socket.recv/3","type":"function","doc":""},{"ref":"KafkaEx.Socket.html#send/2","title":"KafkaEx.Socket.send/2","type":"function","doc":"Sends data over the socket. It handles both, SSL and non SSL sockets. For more information, see :ssl.send/2 for ssl or :gen_tcp.send/2 for non ssl."},{"ref":"KafkaEx.Socket.html#setopts/2","title":"KafkaEx.Socket.setopts/2","type":"function","doc":"Set options to the socket. For more information, see :ssl.setopts/2 for ssl or :inet.setopts/2 for non ssl."},{"ref":"KafkaEx.Socket.html#t:t/0","title":"KafkaEx.Socket.t/0","type":"type","doc":""},{"ref":"KafkaEx.TimestampNotSupportedError.html","title":"KafkaEx.TimestampNotSupportedError","type":"exception","doc":""},{"ref":"KafkaEx.Utils.Murmur.html","title":"KafkaEx.Utils.Murmur","type":"module","doc":"Utility module that provides Murmur hashing algorithm."},{"ref":"KafkaEx.Utils.Murmur.html#murmur2/1","title":"KafkaEx.Utils.Murmur.murmur2/1","type":"function","doc":"Calculates murmur2 hash for given binary"},{"ref":"KafkaEx.Utils.Murmur.html#umurmur2/1","title":"KafkaEx.Utils.Murmur.umurmur2/1","type":"function","doc":"Calculates murmur2 hash for given binary as unsigned 32-bit integer"},{"ref":"KafkaEx.Utils.Murmur.html#umurmur2_legacy/1","title":"KafkaEx.Utils.Murmur.umurmur2_legacy/1","type":"function","doc":"Calculates murmur2 hash for given binary as unsigned 32-bit integer This is to support the legacy default partitioner implementation."},{"ref":"readme.html","title":"KafkaEx","type":"extras","doc":"KafkaEx KafkaEx is an Elixir client for Apache Kafka with support for Kafka versions 0.8.0 and newer. KafkaEx requires Elixir 1.5+ and Erlang OTP 19+. See http://hexdocs.pm/kafka_ex/ for documentation, https://github.com/kafkaex/kafka_ex/ for code. KakfaEx supports the following Kafka features: Broker and Topic Metadata Produce Messages Fetch Messages Message Compression with Snappy and gzip Offset Management (fetch / commit / autocommit) Consumer Groups Topics Management (create / delete) See Kafka Protocol Documentation and A Guide to the Kafka Protocol for details of these features."},{"ref":"readme.html#important-kayrock-and-the-future-of-kafkaex","title":"KafkaEx - IMPORTANT - Kayrock and The Future of KafkaEx","type":"extras","doc":"TL;DR: This is new implementation and we need people to test it! Set kafka_version: &quot;kayrock&quot; to use the new client implementation. The new client should be compatible with existing code when used this way. Many functions now suppoert an api_version parameter, see below for details, e.g., how to store offsets in Kafka instead of Zookeeper. Version 1.0 of KafkaEx will be based on Kayrock and have a cleaner API - you can start testing this API by using modules from the KafkaEx.New namespace. See below for details. Version 0.11.0+ of KafkaEx is required to use Kayrock. To support some oft-requested features (offset storage in Kafka, message timestamps), we have integrated KafkaEx with Kayrock which is a library that handles serialization and deserialization of the Kafka message protocol in a way that can grow as Kafka does. Unfortunately, the existing KafkaEx API is built in such a way that it doesn&#39;t easily support this growth. This, combined with a number of other existing warts in the current API, has led us to the conclusion that v1.0 of KafkaEx should have a new and cleaner API. The path we have planned to get to v1.0 is: Add a Kayrock compatibility layer for the existing KafkaEx API (DONE, not released). Expose Kayrock&#39;s API versioning through a select handful of KafkaEx API functions so that users can get access to the most-requested features (e.g., offset storage in Kafka and message timestamps) (DONE, not released). Begin designing and implementing the new API in parallel in the KafkaEx.New namespace (EARLY PROGRESS). Incrementally release the new API alongside the legacy API so that early adopters can test it. Once the new API is complete and stable, move it to the KafkaEx namespace (i.e., drop the New part) and it will replace the legacy API. This will be released as v1.0. Users of KafkaEx can help a lot by testing the new code. At first, we need people to test the Kayrock-based client using compatibility mode. You can do this by simply setting kafka_version: &quot;kayrock&quot; in your configuration. That should be all you need to change. If you want to test new features enabled by api_versions options then that is also very valuable to us (see below for links to details). Then, as work on the new API ramps up, users can contribute feedback to pull requests (or even contribute pull requests!) and test out the new API as it becomes available. For more information on using the Kayrock-based client, see Github: kayrock.md HexDocs: kayrock-based client For more information on the v1.0 API, see Github: new_api.md HexDocs: New API"},{"ref":"readme.html#using-kafkaex-in-an-elixir-project","title":"KafkaEx - Using KafkaEx in an Elixir project","type":"extras","doc":"The standard approach for adding dependencies to an Elixir application applies: add KafkaEx to the deps list in your project&#39;s mix.exs file. You may also optionally add snappy-erlang-nif (required only if you want to use snappy compression). # mix.exs defmodule MyApp.Mixfile do # ... defp deps do [ # add to your existing deps {:kafka_ex, &quot;~&gt; 0.11&quot;}, # if using snappy compression {:snappy, git: &quot;https://github.com/fdmanana/snappy-erlang-nif&quot;} ] end end Then run mix deps.get to fetch dependencies."},{"ref":"readme.html#configuration","title":"KafkaEx - Configuration","type":"extras","doc":"See config/config.exs or KafkaEx.Config for a description of configuration variables, including the Kafka broker list and default consumer group. You can also override options when creating a worker, see below."},{"ref":"readme.html#timeouts-with-ssl","title":"KafkaEx - Timeouts with SSL","type":"extras","doc":"When using certain versions of OTP, random timeouts can occur if using SSL. Impacted versions: OTP 21.3.8.1 -&gt; 21.3.8.14 OTP 22.1 -&gt; 22.3.1 Upgrade respectively to 21.3.8.15 or 22.3.2 to solve this."},{"ref":"readme.html#usage-examples","title":"KafkaEx - Usage Examples","type":"extras","doc":"Consumer Groups To use a consumer group, first implement a handler module using KafkaEx.GenConsumer. defmodule ExampleGenConsumer do use KafkaEx.GenConsumer alias KafkaEx.Protocol.Fetch.Message require Logger # note - messages are delivered in batches def handle_message_set(message_set, state) do for %Message{value: message} &lt;- message_set do Logger.debug(fn -&gt; &quot;message: &quot; &lt;&gt; inspect(message) end) end {:async_commit, state} end end Then add a KafkaEx.ConsumerGroup to your application&#39;s supervision tree and configure it to use the implementation module. See the KafkaEx.GenConsumer and KafkaEx.ConsumerGroup documentation for details. Create a KafkaEx Worker KafkaEx worker processes manage the state of the connection to the Kafka broker. iex&gt; KafkaEx.create_worker(:pr) # where :pr is the process name of the created worker {:ok, #PID&lt;0.171.0&gt;} With custom options: iex&gt; uris = [{&quot;localhost&quot;, 9092}, {&quot;localhost&quot;, 9093}, {&quot;localhost&quot;, 9094}] [{&quot;localhost&quot;, 9092}, {&quot;localhost&quot;, 9093}, {&quot;localhost&quot;, 9094}] iex&gt; KafkaEx.create_worker(:pr, [uris: uris, consumer_group: &quot;kafka_ex&quot;, consumer_group_update_interval: 100]) {:ok, #PID&lt;0.172.0&gt;} Create an unnamed KafkaEx worker You may find you want to create many workers, say in conjunction with a poolboy pool. In this scenario you usually won&#39;t want to name these worker processes. To create an unnamed worked with create_worker: iex&gt; KafkaEx.create_worker(:no_name) # indicates to the server process not to name the process {:ok, #PID&lt;0.171.0&gt;} Use KafkaEx with a pooling library Note that KafkaEx has a supervisor to manage its workers. If you are using Poolboy or a similar library, you will want to manually create a worker so that it is not supervised by KafkaEx.Supervisor. To do this, you will need to call: GenServer.start_link(KafkaEx.Config.server_impl, [ [uris: KafkaEx.Config.brokers(), consumer_group: Application.get_env(:kafka_ex, :consumer_group)], :no_name ] ) Alternatively, you can call KafkaEx.start_link_worker(:no_name) Retrieve kafka metadata For all metadata iex&gt; KafkaEx.metadata %KafkaEx.Protocol.Metadata.Response{brokers: [%KafkaEx.Protocol.Metadata.Broker{host: &quot;192.168.59.103&quot;, node_id: 49162, port: 49162, socket: nil}], topic_metadatas: [%KafkaEx.Protocol.Metadata.TopicMetadata{error_code: :no_error, partition_metadatas: [%KafkaEx.Protocol.Metadata.PartitionMetadata{error_code: :no_error, isrs: [49162], leader: 49162, partition_id: 0, replicas: [49162]}], topic: &quot;LRCYFQDVWUFEIUCCTFGP&quot;}, %KafkaEx.Protocol.Metadata.TopicMetadata{error_code: :no_error, partition_metadatas: [%KafkaEx.Protocol.Metadata.PartitionMetadata{error_code: :no_error, isrs: [49162], leader: 49162, partition_id: 0, replicas: [49162]}], topic: &quot;JSIMKCLQYTWXMSIGESYL&quot;}, %KafkaEx.Protocol.Metadata.TopicMetadata{error_code: :no_error, partition_metadatas: [%KafkaEx.Protocol.Metadata.PartitionMetadata{error_code: :no_error, isrs: [49162], leader: 49162, partition_id: 0, replicas: [49162]}], topic: &quot;SCFRRXXLDFPOWSPQQMSD&quot;}, %KafkaEx.Protocol.Metadata.TopicMetadata{error_code: :no_error, ... For a specific topic iex&gt; KafkaEx.metadata(topic: &quot;foo&quot;) %KafkaEx.Protocol.Metadata.Response{brokers: [%KafkaEx.Protocol.Metadata.Broker{host: &quot;192.168.59.103&quot;, node_id: 49162, port: 49162, socket: nil}], topic_metadatas: [%KafkaEx.Protocol.Metadata.TopicMetadata{error_code: :no_error, partition_metadatas: [%KafkaEx.Protocol.Metadata.PartitionMetadata{error_code: :no_error, isrs: [49162], leader: 49162, partition_id: 0, replicas: [49162]}], topic: &quot;foo&quot;}]} Retrieve offset from a particular time Kafka will get the starting offset of the log segment that is created no later than the given timestamp. Due to this, and since the offset request is served only at segment granularity, the offset fetch request returns less accurate results for larger segment sizes. iex&gt; KafkaEx.offset(&quot;foo&quot;, 0, {{2015, 3, 29}, {23, 56, 40}}) # Note that the time specified should match/be ahead of time on the server that kafka runs [%KafkaEx.Protocol.Offset.Response{partition_offsets: [%{error_code: :no_error, offset: [256], partition: 0}], topic: &quot;foo&quot;}] Retrieve the latest offset iex&gt; KafkaEx.latest_offset(&quot;foo&quot;, 0) # where 0 is the partition [%KafkaEx.Protocol.Offset.Response{partition_offsets: [%{error_code: :no_error, offset: [16], partition: 0}], topic: &quot;foo&quot;}] Retrieve the earliest offset iex&gt; KafkaEx.earliest_offset(&quot;foo&quot;, 0) # where 0 is the partition [%KafkaEx.Protocol.Offset.Response{partition_offsets: [%{error_code: :no_error, offset: [0], partition: 0}], topic: &quot;foo&quot;}] Fetch kafka logs NOTE You must pass auto_commit: false in the options for fetch/3 when using Kafka &lt; 0.8.2 or when using :no_consumer_group. iex&gt; KafkaEx.fetch(&quot;foo&quot;, 0, offset: 5) # where 0 is the partition and 5 is the offset we want to start fetching from [%KafkaEx.Protocol.Fetch.Response{partitions: [%{error_code: :no_error, hw_mark_offset: 115, message_set: [ %KafkaEx.Protocol.Fetch.Message{attributes: 0, crc: 4264455069, key: nil, offset: 5, value: &quot;hey&quot;}, %KafkaEx.Protocol.Fetch.Message{attributes: 0, crc: 4264455069, key: nil, offset: 6, value: &quot;hey&quot;}, %KafkaEx.Protocol.Fetch.Message{attributes: 0, crc: 4264455069, key: nil, offset: 7, value: &quot;hey&quot;}, %KafkaEx.Protocol.Fetch.Message{attributes: 0, crc: 4264455069, key: nil, offset: 8, value: &quot;hey&quot;}, %KafkaEx.Protocol.Fetch.Message{attributes: 0, crc: 4264455069, key: nil, offset: 9, value: &quot;hey&quot;} ...], partition: 0}], topic: &quot;foo&quot;}] Produce kafka logs iex&gt; KafkaEx.produce(&quot;foo&quot;, 0, &quot;hey&quot;) # where &quot;foo&quot; is the topic and &quot;hey&quot; is the message :ok Stream kafka logs See the KafkaEx.stream/3 documentation for details on streaming. iex&gt; KafkaEx.produce(&quot;foo&quot;, 0, &quot;hey&quot;) :ok iex&gt; KafkaEx.produce(&quot;foo&quot;, 0, &quot;hi&quot;) :ok iex&gt; KafkaEx.stream(&quot;foo&quot;, 0, offset: 0) |&gt; Enum.take(2) [%{attributes: 0, crc: 4264455069, key: nil, offset: 0, value: &quot;hey&quot;}, %{attributes: 0, crc: 4251893211, key: nil, offset: 1, value: &quot;hi&quot;}] For Kafka &lt; 0.8.2 the stream/3 requires auto_commit: false iex&gt; KafkaEx.stream(&quot;foo&quot;, 0, offset: 0, auto_commit: false) |&gt; Enum.take(2) Compression Snappy and gzip compression is supported. Example usage for producing compressed messages: message1 = %KafkaEx.Protocol.Produce.Message{value: &quot;value 1&quot;} message2 = %KafkaEx.Protocol.Produce.Message{key: &quot;key 2&quot;, value: &quot;value 2&quot;} messages = [message1, message2] #snappy produce_request = %KafkaEx.Protocol.Produce.Request{ topic: &quot;test_topic&quot;, partition: 0, required_acks: 1, compression: :snappy, messages: messages} KafkaEx.produce(produce_request) #gzip produce_request = %KafkaEx.Protocol.Produce.Request{ topic: &quot;test_topic&quot;, partition: 0, required_acks: 1, compression: :gzip, messages: messages} KafkaEx.produce(produce_request) Compression is handled automatically on the consuming/fetching end."},{"ref":"readme.html#testing","title":"KafkaEx - Testing","type":"extras","doc":"It is strongly recommended to test using the Dockerized test cluster described below. This is required for contributions to KafkaEx. NOTE You may have to run the test suite twice to get tests to pass. Due to asynchronous issues, the test suite sometimes fails on the first try. Dockerized Test Cluster Testing KafkaEx requires a local SSL-enabled Kafka cluster with 3 nodes: one node listening on each port 9092, 9093, and 9093. The easiest way to do this is using the scripts in this repository that utilize Docker and Docker Compose (both of which are freely available). This is the method we use for our CI testing of KafkaEx. To launch the included test cluster, run ./scripts/docker_up.sh The docker_up.sh script will attempt to determine an IP address for your computer on an active network interface. The test cluster runs Kafka 0.11.0.1. Running the KafkaEx Tests The KafkaEx tests are split up using tags to handle testing multiple scenarios and Kafka versions. Unit tests These tests do not require a Kafka cluster to be running (see test/test_helper.exs:3 for the tags excluded when running this). mix test --no-start Integration tests If you are not using the Docker test cluster, you may need to modify config/config.exs for your set up. The full test suite requires Kafka 0.10.1.0+. Kafka &gt;= 0.9.0 The 0.9 client includes functionality that cannot be tested with older clusters. ./all_tests.sh Kafka = 0.9.0 The 0.9 client includes functionality that cannot be tested with older clusters. mix test --include integration --include consumer_group --include server_0_p_9_p_0 Kafka &gt;= 0.8.2 and &lt; 0.9.0 Kafka 0.8.2 introduced the consumer group API. mix test --include consumer_group --include integration Kafka &lt; 0.8.2 If your test cluster is older, the consumer group tests must be omitted. mix test --include integration --include server_0_p_8_p_0 Static analysis mix dialyzer"},{"ref":"readme.html#contributing","title":"KafkaEx - Contributing","type":"extras","doc":"All contributions are managed through the kafkaex github repo. If you find a bug or would like to contribute, please open an issue or submit a pull request. Please refer to CONTRIBUTING.md for our contribution process. KafkaEx has a Slack channel: #kafkaex on elixir-lang.slack.com. You can request an invite via http://bit.ly/slackelixir. The Slack channel is appropriate for quick questions or general design discussions. The Slack discussion is archived at http://slack.elixirhq.com/kafkaex."},{"ref":"kayrock.html","title":"Kayrock-Based KafkaEx Client","type":"extras","doc":"Kayrock-Based KafkaEx Client This document contains information on using the new Kayrock-based KafkaEx client. The client itself is defined in the module KafkaEx.New.Client. This will be the primary KafkaEx client module going forward. NOTE In many places below we recommend using &quot;version N and up&quot;. The reality is that in many cases, the KafkaEx legacy API compatibility only supports versions 0 to 3. Using version 3 should generally be safe and achieve the desired outcomes. The new API will be designed to handle newer versions. Contents: Using the New Client Common Use Case - Store Offsets In Kafka Common Use Case - Message Timestamps / New Storage Format"},{"ref":"kayrock.html#using-the-new-client","title":"Kayrock-Based KafkaEx Client - Using the New Client","type":"extras","doc":"To use the new client in your project, set kafka_version: &quot;kayrock&quot; in your config file: config :kafka_ex, kafka_version: &quot;kayrock&quot; If want to start a single client instance, supply the new client&#39;s module name to the :server_impl option of KafkaEx.start_link_worker/2: {:ok, pid} = KafkaEx.start_link_worker(:no_name, server_impl: KafkaEx.New.Client) The new client should be totally backwards compatible with the legacy API; simply use KafkaEx like you normally would. It is also compatible with the new API defined in KafkaEx.New.KafkaExAPI."},{"ref":"kayrock.html#common-use-case-store-offsets-in-kafka","title":"Kayrock-Based KafkaEx Client - Common Use Case - Store Offsets In Kafka","type":"extras","doc":"Offsets are stored in Kafka (instead of Zookeeper) with offset commit message version 1 and up (Kafka v0.10 and up). Message version 1 also includes a timestamp parameter that was dropped in version 2, so we recommend using at least version 2. We often use version 3 out of convenience because that version number achieves desired results with this and other Kafka API messages. To retrieve offsets committed with version 1 and up, you must also use version 1 and up of the offset fetch request. A safe move here is to always use the same version for offset commit and offset fetch. WARNING - OFFSET LOSS If offsets for a consumer group are stored in Zookeeper (v0 KafkaEx legacy), they are unavailable using v1 and up of the offset fetch message. This means that if you have an existing KafkaEx consumer group and &quot;upgrade&quot; to the new version, you will lose offsets. To avoid losing offsets, you should first convert the Zookeeper offsets to Kafka storage. This can be achieved using command line tools (documentation of which is beyond the scope of this document) or using KafkaEx by fetching the offsets using v0 and then committing them using v1. We may provide a tool for this in the future. Likewise, once you store offsets in Kafka, they cannot be fetched using v0 of the offet fetch message. If you need to &quot;roll back&quot; storage from Kafka to Zookeeper, you will need to convert the offsets first. Examples KafkaEx.offset_commit/2 and KafkaEx.offset_fetch/2 support setting the api version via the api_version field of their corresponding requests structs: alias KafkaEx.Protocol.OffsetCommit # commit offsets using kafka storage KafkaEx.offset_commit(client, %OffsetCommit.Request{ consumer_group: consumer_group, topic: topic, partition: 0, offset: offset, api_version: 3 }) # fetch an offset stored in kafka [resp] = KafkaEx.offset_fetch(client, %OffsetFetch.Request{ topic: topic, consumer_group: consumer_group, partition: 0, api_version: 3 }) %KafkaEx.Protocol.OffsetFetch.Response{partitions: [%{offset: offset}]} = resp When using KafkaEx.fetch/3 with auto_commit: true, you can specify the offset_commit_api_version option to control how offsets are stored: # store auto-committed offsets in kafka KafkaEx.fetch(topic, partition, auto_commit: true, offset_commit_api_version: 3) When using KafkaEx.ConsumerGroup, you can control offset storage using the api_versions option: # use kafka offset storage with consumer groups # NOTE you must use compatible version for offset_fetch and offset_commit # using the same value for both should be safe KafkaEx.ConsumerGroup.start_link( MyConsumer, consumer_group_name, [topic], api_versions: %{offset_fetch: 3, offset_commit: 3} )"},{"ref":"kayrock.html#common-use-case-message-timestamps-new-storage-format","title":"Kayrock-Based KafkaEx Client - Common Use Case - Message Timestamps / New Storage Format","type":"extras","doc":"Message timestamps and the new message storage format go hand-in-hand because they both require setting the message versions for produce and fetch. Timestamps were added in v1 of the produce/fetch messages, but the storage format was replaced in v2 (around Kafka v0.10), so we recommend using 2 and up (3 is safe). WARNING - Broker Performance Check with your system administrator. If the broker is configured to use the new message format (v2 and up), producing or requesting messages with old formats (v0 and v1) can lead to significant load on the brokers because they will need to convert messages between versions for each request. If you have a relatively modern version of Kafka, we recommend using version 3 for both messages. Examples Whenever we use produce API version &gt;= 2, the new message format is used automatically. To publish a message with a timestamp: {:ok, offset} = KafkaEx.produce( topic, 0, msg, worker_name: client, required_acks: 1, timestamp: 12345, api_version: 3 ) fetch_responses = KafkaEx.fetch(topic, 0, offset: offset, auto_commit: false, worker_name: client, api_version: 3 ) [fetch_response | _] = fetch_responses [partition_response | _] = fetch_response.partitions message = List.last(partition_response.message_set) message.value # =&gt; msg message.offset # =&gt; offste message.timestamp # =&gt; 12345 If a topic has the message.timestamp.type setting set to LogAppendTime, then timestamps will be populated automatically when a produced message is received by the broker and appended to the log. fetch_responses = KafkaEx.fetch(topic_with_log_append_timestamps, 0, offset: offset, auto_commit: false, worker_name: client, api_version: 3 ) [fetch_response | _] = fetch_responses [partition_response | _] = fetch_response.partitions message = List.last(partition_response.message_set) message.timestamp # =&gt; log append timestamp in milliseconds Note that the KafkaEx.ConsumerGroup api_versions option also supports setting a versino for fetch: # use new record batch format AND kafka offset storage with consumer groups KafkaEx.ConsumerGroup.start_link( MyConsumer, consumer_group_name, [topic], api_versions: %{offset_fetch: 3, offset_commit: 3, fetch: 3} )"},{"ref":"new_api.html","title":"KafkaEx 1.0 API","type":"extras","doc":"KafkaEx 1.0 API This document describes the design approach and gives an overview of thew new client API. The API itself is documented in KafkaEx.New.KafkaExAPI. The current plan is for KafkaEx.New.KafkaExAPI to replace KafkaEx in the v1.0 release. The new API is designed to continue to provide a useful Kafka client API foremost, to address some of the limitations and inconveniences of the existing API (both in terms of usage and maintenance). A central goal of the new API is to allow us to support new Kafka features more rapidly than in the past."},{"ref":"new_api.html#status","title":"KafkaEx 1.0 API - Status","type":"extras","doc":"The new API is still in very early stages of development. We will try to keep this section up-to-date with respect to what features have been implemented. KafkaEx.New.KafkaExAPI is the source of truth for this summary. Features implemented: Get latest offset for a partition as {:ok, offset} or {:error, error_code} (no more fishing through the response structs). Get metadata for an arbitrary list of topics"},{"ref":"new_api.html#major-differences-from-the-legacy-api","title":"KafkaEx 1.0 API - Major Differences from the Legacy API","type":"extras","doc":"There is currently no supervisor for clients. It is assumed that the user will manage these when not used in a consumer group. (This does not apply to clients started via the legacy create_worker API, which are started under the standard supervision tree.) The client does not automatically fetch metadata for all topics as this can lead to timeouts on large clusters. There should be no observable impact here because the client fetches metadata for specific topics on-demand. A client is no longer &quot;attached&quot; to a specific consumer group. In the legacy implementation this was a consequence of the way autocommit was handled."},{"ref":"new_api.html#design-philosophy","title":"KafkaEx 1.0 API - Design Philosophy","type":"extras","doc":"Two main design principles in the new client are driven by factors that made maintenance of the legacy API difficult: Delegate and genericize API message version handling Kafka API message serialization and deserialization has been externalized to a library (Kayrock) that can easily support new message formats as they are released. Kayrock exposes a generic serialize/deserialize functionality, which means we do not have to write code to handle specific versions of specific messages at a low level in KafkaEx. Separation of connection state management and API logic As much as possible, we avoid putting API logic inside the client GenServer. Instead, we write functions that form Kayrock request structs based on user input, use KafkaEx.New.Client.send_request/3 to perform communication with the cluster, and then act accordingly based on the response. Example: Fetching Kafka Config Values Suppose that we wanted to implement a function to retrieve Kafka broker config settings. This is the DescribeConfig API and corresponds to the Kayrock.DescribeConfig namespace. After some research (and trial-and-error using iex and functions like the ones below), we find that to fetch broker settings, we find that we need to set resource_type to 4 and resource_name to the string representation of the broker&#39;s id number (e.g., 1 =&gt; &quot;1&quot;): # List all config values for node 1 of the cluster {:ok, pid} = KafkaEx.start_link_worker(:no_name, server_impl: KafkaEx.New.Client) # resource type 4 is &#39;broker&#39; req = %Kayrock.DescribeConfigs.V0.Request{ resources: [%{resource_type: 4, resource_name: &quot;1&quot;, config_names: nil}] } KafkaEx.New.Client.send_request(pid, req, KafkaEx.New.NodeSelector.node_id(1)) {:ok, %Kayrock.DescribeConfigs.V0.Response{ correlation_id: 15, resources: [ %{ config_entries: [ %{ config_name: &quot;advertised.host.name&quot;, config_value: nil, is_default: 1, is_sensitive: 0, read_only: 1 }, %{ config_name: &quot;log.cleaner.min.compaction.lag.ms&quot;, config_value: &quot;0&quot;, is_default: 1, is_sensitive: 0, read_only: 1 }, ... ] } ] }} From the above, we could feasibly write a convenience function to fetch broker configs and doing so would not require us to modify the client code at all. Furthermore, as the DescribeConfigs API changes over time, we can easily support it by changing only that function. The goal of the new API is that most simple functionality can be implemented simply by writing such a function: alias KafkaEx.New.Client alias KafkaEx.New.NodeSelector def get_broker_config_values(client, config_names, broker_id) do request = %Kayrock.DescribeConfigs.V0.Request{ resources: [%{ resource_type: 4, resource_name: &quot;\#{broker_id}&quot;, config_names: config_names }] } # note this requires no changes to the client itself {:ok, %{ resources: [ %{ error_code: 0, config_entries: config_entries } ] }} = Client.send_request(client, request, NodeSelector.node_id(broker_id)) config_entries end This implementation only supports version 0 of the DescribeConfigs API. We can achieve some level of forward compatibility by adding an opts keyword list and some code to handle api_version in the opts: def get_broker_config_values(client, config_names, broker_id, opts \\\\ []) do api_version = Keywork.get(opts, :api_version, 0) # a setting in v1+ include_synonyms = Keyword.get(opts, :include_synonyms, false) request = Kayrock.DescribeConfigs.get_request_struct(api_version) request = if api_version &gt; 1 do %{request | include_synonyms: include_synonyms} else request end # rest is the same end"}]