sidebarNodes={"extras":[{"id":"api-reference","title":"API Reference","group":"","headers":[{"id":"Modules","anchor":"modules"},{"id":"Exceptions","anchor":"exceptions"}]},{"id":"readme","title":"KafkaEx","group":"","headers":[{"id":"IMPORTANT - Kayrock and The Future of KafkaEx","anchor":"important-kayrock-and-the-future-of-kafkaex"},{"id":"Using KafkaEx in an Elixir project","anchor":"using-kafkaex-in-an-elixir-project"},{"id":"Configuration","anchor":"configuration"},{"id":"Timeouts with SSL","anchor":"timeouts-with-ssl"},{"id":"Usage Examples","anchor":"usage-examples"},{"id":"Testing","anchor":"testing"},{"id":"Contributing","anchor":"contributing"}]},{"id":"kayrock","title":"Kayrock-Based KafkaEx Client","group":"","headers":[{"id":"Using the New Client","anchor":"using-the-new-client"},{"id":"Common Use Case - Store Offsets In Kafka","anchor":"common-use-case-store-offsets-in-kafka"},{"id":"Common Use Case - Message Timestamps / New Storage Format","anchor":"common-use-case-message-timestamps-new-storage-format"}]},{"id":"new_api","title":"KafkaEx 1.0 API","group":"","headers":[{"id":"Status","anchor":"status"},{"id":"Major Differences from the Legacy API","anchor":"major-differences-from-the-legacy-api"},{"id":"Design Philosophy","anchor":"design-philosophy"}]}],"exceptions":[{"id":"KafkaEx.ConsumerGroupRequiredError","title":"KafkaEx.ConsumerGroupRequiredError","group":""},{"id":"KafkaEx.InvalidConsumerGroupError","title":"KafkaEx.InvalidConsumerGroupError","group":""},{"id":"KafkaEx.TimestampNotSupportedError","title":"KafkaEx.TimestampNotSupportedError","group":""}],"modules":[{"id":"KafkaEx","title":"KafkaEx","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"ssl_options/0","anchor":"t:ssl_options/0"},{"id":"uri/0","anchor":"t:uri/0"},{"id":"worker_init/0","anchor":"t:worker_init/0"},{"id":"worker_setting/0","anchor":"t:worker_setting/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"api_versions/1","anchor":"api_versions/1"},{"id":"build_worker_options/1","anchor":"build_worker_options/1"},{"id":"consumer_group/1","anchor":"consumer_group/1"},{"id":"consumer_group_metadata/2","anchor":"consumer_group_metadata/2"},{"id":"create_topics/2","anchor":"create_topics/2"},{"id":"create_worker/2","anchor":"create_worker/2"},{"id":"delete_topics/2","anchor":"delete_topics/2"},{"id":"earliest_offset/3","anchor":"earliest_offset/3"},{"id":"fetch/3","anchor":"fetch/3"},{"id":"heartbeat/2","anchor":"heartbeat/2"},{"id":"join_group/2","anchor":"join_group/2"},{"id":"latest_offset/3","anchor":"latest_offset/3"},{"id":"leave_group/2","anchor":"leave_group/2"},{"id":"metadata/1","anchor":"metadata/1"},{"id":"offset/4","anchor":"offset/4"},{"id":"offset_commit/2","anchor":"offset_commit/2"},{"id":"offset_fetch/2","anchor":"offset_fetch/2"},{"id":"produce/2","anchor":"produce/2"},{"id":"produce/4","anchor":"produce/4"},{"id":"start/2","anchor":"start/2"},{"id":"start_link_worker/2","anchor":"start_link_worker/2"},{"id":"stop_worker/1","anchor":"stop_worker/1"},{"id":"stream/3","anchor":"stream/3"},{"id":"sync_group/2","anchor":"sync_group/2"},{"id":"valid_consumer_group?/1","anchor":"valid_consumer_group?/1"}]}]},{"id":"KafkaEx.Compression","title":"KafkaEx.Compression","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"attribute_t/0","anchor":"t:attribute_t/0"},{"id":"compression_type_t/0","anchor":"t:compression_type_t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"compress/2","anchor":"compress/2"},{"id":"decompress/2","anchor":"decompress/2"},{"id":"snappy_decompress_chunk/2","anchor":"snappy_decompress_chunk/2"}]}]},{"id":"KafkaEx.Config","title":"KafkaEx.Config","group":""},{"id":"KafkaEx.ConsumerGroup","title":"KafkaEx.ConsumerGroup","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"option/0","anchor":"t:option/0"},{"id":"options/0","anchor":"t:options/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"active?/2","anchor":"active?/2"},{"id":"assignments/2","anchor":"assignments/2"},{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"consumer_pids/1","anchor":"consumer_pids/1"},{"id":"consumer_supervisor_pid/2","anchor":"consumer_supervisor_pid/2"},{"id":"generation_id/2","anchor":"generation_id/2"},{"id":"get_manager_pid/1","anchor":"get_manager_pid/1"},{"id":"group_name/2","anchor":"group_name/2"},{"id":"leader?/2","anchor":"leader?/2"},{"id":"leader_id/2","anchor":"leader_id/2"},{"id":"member_id/2","anchor":"member_id/2"},{"id":"partition_consumer_map/1","anchor":"partition_consumer_map/1"},{"id":"start_link/4","anchor":"start_link/4"}]}]},{"id":"KafkaEx.ConsumerGroup.PartitionAssignment","title":"KafkaEx.ConsumerGroup.PartitionAssignment","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"callback/0","anchor":"t:callback/0"},{"id":"member_id/0","anchor":"t:member_id/0"},{"id":"partition/0","anchor":"t:partition/0"},{"id":"partition_id/0","anchor":"t:partition_id/0"},{"id":"topic/0","anchor":"t:topic/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"round_robin/2","anchor":"round_robin/2"}]}]},{"id":"KafkaEx.DefaultPartitioner","title":"KafkaEx.DefaultPartitioner","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"assign_partition/2","anchor":"assign_partition/2"}]}]},{"id":"KafkaEx.GenConsumer","title":"KafkaEx.GenConsumer","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"option/0","anchor":"t:option/0"},{"id":"options/0","anchor":"t:options/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"call/3","anchor":"call/3"},{"id":"cast/2","anchor":"cast/2"},{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"init/1","anchor":"init/1"},{"id":"partition/2","anchor":"partition/2"},{"id":"start_link/5","anchor":"start_link/5"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"handle_call/3","anchor":"c:handle_call/3"},{"id":"handle_cast/2","anchor":"c:handle_cast/2"},{"id":"handle_info/2","anchor":"c:handle_info/2"},{"id":"handle_message_set/2","anchor":"c:handle_message_set/2"},{"id":"init/2","anchor":"c:init/2"},{"id":"init/3","anchor":"c:init/3"}]}]},{"id":"KafkaEx.GenConsumer.Supervisor","title":"KafkaEx.GenConsumer.Supervisor","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"active?/1","anchor":"active?/1"},{"id":"child_pids/1","anchor":"child_pids/1"},{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"init/1","anchor":"init/1"},{"id":"start_link/4","anchor":"start_link/4"}]}]},{"id":"KafkaEx.LegacyPartitioner","title":"KafkaEx.LegacyPartitioner","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"assign_partition/2","anchor":"assign_partition/2"}]}]},{"id":"KafkaEx.New.Broker","title":"KafkaEx.New.Broker","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"has_socket?/2","anchor":"has_socket?/2"}]}]},{"id":"KafkaEx.New.Client","title":"KafkaEx.New.Client","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"args/0","anchor":"t:args/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"send_request/4","anchor":"send_request/4"},{"id":"start_link/2","anchor":"start_link/2"}]}]},{"id":"KafkaEx.New.ClusterMetadata","title":"KafkaEx.New.ClusterMetadata","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"node_select_error/0","anchor":"t:node_select_error/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"broker_by_node_id/2","anchor":"broker_by_node_id/2"},{"id":"brokers/1","anchor":"brokers/1"},{"id":"from_metadata_v1_response/1","anchor":"from_metadata_v1_response/1"},{"id":"known_topics/1","anchor":"known_topics/1"},{"id":"select_node/2","anchor":"select_node/2"},{"id":"topics_metadata/2","anchor":"topics_metadata/2"}]}]},{"id":"KafkaEx.New.KafkaExAPI","title":"KafkaEx.New.KafkaExAPI","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"client/0","anchor":"t:client/0"},{"id":"consumer_group_name/0","anchor":"t:consumer_group_name/0"},{"id":"correlation_id/0","anchor":"t:correlation_id/0"},{"id":"error_atom/0","anchor":"t:error_atom/0"},{"id":"node_id/0","anchor":"t:node_id/0"},{"id":"offset/0","anchor":"t:offset/0"},{"id":"partition_id/0","anchor":"t:partition_id/0"},{"id":"topic_name/0","anchor":"t:topic_name/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"cluster_metadata/1","anchor":"cluster_metadata/1"},{"id":"correlation_id/1","anchor":"correlation_id/1"},{"id":"latest_offset/3","anchor":"latest_offset/3"},{"id":"set_consumer_group_for_auto_commit/2","anchor":"set_consumer_group_for_auto_commit/2"},{"id":"topics_metadata/3","anchor":"topics_metadata/3"}]}]},{"id":"KafkaEx.New.NodeSelector","title":"KafkaEx.New.NodeSelector","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"consumer_group/1","anchor":"consumer_group/1"},{"id":"controller/0","anchor":"controller/0"},{"id":"first_available/0","anchor":"first_available/0"},{"id":"node_id/1","anchor":"node_id/1"},{"id":"random/0","anchor":"random/0"},{"id":"topic_partition/2","anchor":"topic_partition/2"}]}]},{"id":"KafkaEx.New.Partition","title":"KafkaEx.New.Partition","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]}]},{"id":"KafkaEx.New.Topic","title":"KafkaEx.New.Topic","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]}]},{"id":"KafkaEx.Partitioner","title":"KafkaEx.Partitioner","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"get_key/1","anchor":"get_key/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"assign_partition/2","anchor":"c:assign_partition/2"}]}]},{"id":"KafkaEx.Protocol.ApiVersions","title":"KafkaEx.Protocol.ApiVersions","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/3","anchor":"create_request/3"},{"id":"parse_response/2","anchor":"parse_response/2"}]}]},{"id":"KafkaEx.Protocol.Common","title":"KafkaEx.Protocol.Common","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"encode_nullable_string/1","anchor":"encode_nullable_string/1"},{"id":"encode_string/1","anchor":"encode_string/1"},{"id":"map_encode/2","anchor":"map_encode/2"},{"id":"parse_topics/3","anchor":"parse_topics/3"},{"id":"read_array/3","anchor":"read_array/3"},{"id":"topic_data/1","anchor":"topic_data/1"}]}]},{"id":"KafkaEx.Protocol.ConsumerMetadata","title":"KafkaEx.Protocol.ConsumerMetadata","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/3","anchor":"create_request/3"},{"id":"parse_response/1","anchor":"parse_response/1"}]}]},{"id":"KafkaEx.Protocol.CreateTopics","title":"KafkaEx.Protocol.CreateTopics","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"api_version/1","anchor":"api_version/1"},{"id":"create_request/4","anchor":"create_request/4"},{"id":"parse_response/2","anchor":"parse_response/2"}]}]},{"id":"KafkaEx.Protocol.DeleteTopics","title":"KafkaEx.Protocol.DeleteTopics","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"api_version/1","anchor":"api_version/1"},{"id":"create_request/4","anchor":"create_request/4"},{"id":"parse_response/2","anchor":"parse_response/2"}]}]},{"id":"KafkaEx.Protocol.Fetch","title":"KafkaEx.Protocol.Fetch","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/1","anchor":"create_request/1"},{"id":"parse_partitions/4","anchor":"parse_partitions/4"},{"id":"parse_response/1","anchor":"parse_response/1"}]}]},{"id":"KafkaEx.Protocol.Heartbeat","title":"KafkaEx.Protocol.Heartbeat","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/3","anchor":"create_request/3"},{"id":"parse_response/1","anchor":"parse_response/1"}]}]},{"id":"KafkaEx.Protocol.JoinGroup","title":"KafkaEx.Protocol.JoinGroup","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/3","anchor":"create_request/3"},{"id":"parse_response/1","anchor":"parse_response/1"}]}]},{"id":"KafkaEx.Protocol.LeaveGroup","title":"KafkaEx.Protocol.LeaveGroup","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/3","anchor":"create_request/3"},{"id":"parse_response/1","anchor":"parse_response/1"}]}]},{"id":"KafkaEx.Protocol.Metadata","title":"KafkaEx.Protocol.Metadata","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"api_version/1","anchor":"api_version/1"},{"id":"create_request/4","anchor":"create_request/4"},{"id":"parse_response/1","anchor":"parse_response/1"},{"id":"parse_response/2","anchor":"parse_response/2"}]}]},{"id":"KafkaEx.Protocol.Offset","title":"KafkaEx.Protocol.Offset","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/5","anchor":"create_request/5"},{"id":"parse_response/1","anchor":"parse_response/1"},{"id":"parse_time/1","anchor":"parse_time/1"}]}]},{"id":"KafkaEx.Protocol.OffsetCommit","title":"KafkaEx.Protocol.OffsetCommit","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/3","anchor":"create_request/3"},{"id":"parse_response/1","anchor":"parse_response/1"}]}]},{"id":"KafkaEx.Protocol.OffsetFetch","title":"KafkaEx.Protocol.OffsetFetch","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/3","anchor":"create_request/3"},{"id":"parse_partitions/4","anchor":"parse_partitions/4"},{"id":"parse_response/1","anchor":"parse_response/1"}]}]},{"id":"KafkaEx.Protocol.Produce","title":"KafkaEx.Protocol.Produce","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/3","anchor":"create_request/3"},{"id":"parse_partitions/4","anchor":"parse_partitions/4"},{"id":"parse_response/1","anchor":"parse_response/1"}]}]},{"id":"KafkaEx.Protocol.Produce.Message","title":"KafkaEx.Protocol.Produce.Message","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]}]},{"id":"KafkaEx.Protocol.Produce.Request","title":"KafkaEx.Protocol.Produce.Request","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]}]},{"id":"KafkaEx.Protocol.SyncGroup","title":"KafkaEx.Protocol.SyncGroup","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create_request/3","anchor":"create_request/3"},{"id":"parse_response/1","anchor":"parse_response/1"}]}]},{"id":"KafkaEx.Server","title":"KafkaEx.Server","group":"","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"id":"kafka_server_api_versions/1","anchor":"c:kafka_server_api_versions/1"},{"id":"kafka_server_consumer_group/1","anchor":"c:kafka_server_consumer_group/1"},{"id":"kafka_server_consumer_group_metadata/1","anchor":"c:kafka_server_consumer_group_metadata/1"},{"id":"kafka_server_create_topics/3","anchor":"c:kafka_server_create_topics/3"},{"id":"kafka_server_delete_topics/3","anchor":"c:kafka_server_delete_topics/3"},{"id":"kafka_server_fetch/2","anchor":"c:kafka_server_fetch/2"},{"id":"kafka_server_heartbeat/3","anchor":"c:kafka_server_heartbeat/3"},{"id":"kafka_server_init/1","anchor":"c:kafka_server_init/1"},{"id":"kafka_server_join_group/3","anchor":"c:kafka_server_join_group/3"},{"id":"kafka_server_leave_group/3","anchor":"c:kafka_server_leave_group/3"},{"id":"kafka_server_metadata/2","anchor":"c:kafka_server_metadata/2"},{"id":"kafka_server_offset/4","anchor":"c:kafka_server_offset/4"},{"id":"kafka_server_offset_commit/2","anchor":"c:kafka_server_offset_commit/2"},{"id":"kafka_server_offset_fetch/2","anchor":"c:kafka_server_offset_fetch/2"},{"id":"kafka_server_produce/2","anchor":"c:kafka_server_produce/2"},{"id":"kafka_server_sync_group/3","anchor":"c:kafka_server_sync_group/3"},{"id":"kafka_server_update_consumer_metadata/1","anchor":"c:kafka_server_update_consumer_metadata/1"},{"id":"kafka_server_update_metadata/1","anchor":"c:kafka_server_update_metadata/1"}]}]},{"id":"KafkaEx.Server0P10AndLater","title":"KafkaEx.Server0P10AndLater","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"broker_for_consumer_group_with_update/2","anchor":"broker_for_consumer_group_with_update/2"},{"id":"consumer_group?/1","anchor":"consumer_group?/1"},{"id":"handle_call/3","anchor":"handle_call/3"},{"id":"handle_info/2","anchor":"handle_info/2"},{"id":"init/1","anchor":"init/1"},{"id":"kafka_server_api_versions/1","anchor":"kafka_server_api_versions/1"},{"id":"kafka_server_consumer_group/1","anchor":"kafka_server_consumer_group/1"},{"id":"kafka_server_consumer_group_metadata/1","anchor":"kafka_server_consumer_group_metadata/1"},{"id":"kafka_server_create_topics/3","anchor":"kafka_server_create_topics/3"},{"id":"kafka_server_delete_topics/3","anchor":"kafka_server_delete_topics/3"},{"id":"kafka_server_fetch/2","anchor":"kafka_server_fetch/2"},{"id":"kafka_server_heartbeat/3","anchor":"kafka_server_heartbeat/3"},{"id":"kafka_server_init/1","anchor":"kafka_server_init/1"},{"id":"kafka_server_join_group/3","anchor":"kafka_server_join_group/3"},{"id":"kafka_server_leave_group/3","anchor":"kafka_server_leave_group/3"},{"id":"kafka_server_metadata/2","anchor":"kafka_server_metadata/2"},{"id":"kafka_server_offset/4","anchor":"kafka_server_offset/4"},{"id":"kafka_server_offset_commit/2","anchor":"kafka_server_offset_commit/2"},{"id":"kafka_server_offset_fetch/2","anchor":"kafka_server_offset_fetch/2"},{"id":"kafka_server_produce/2","anchor":"kafka_server_produce/2"},{"id":"kafka_server_produce_send_request/4","anchor":"kafka_server_produce_send_request/4"},{"id":"kafka_server_sync_group/3","anchor":"kafka_server_sync_group/3"},{"id":"kafka_server_update_consumer_metadata/1","anchor":"kafka_server_update_consumer_metadata/1"},{"id":"kafka_server_update_metadata/1","anchor":"kafka_server_update_metadata/1"},{"id":"retrieve_metadata/5","anchor":"retrieve_metadata/5"},{"id":"retrieve_metadata/7","anchor":"retrieve_metadata/7"},{"id":"retrieve_metadata_with_version/7","anchor":"retrieve_metadata_with_version/7"},{"id":"start_link/2","anchor":"start_link/2"},{"id":"terminate/2","anchor":"terminate/2"},{"id":"update_consumer_metadata/3","anchor":"update_consumer_metadata/3"},{"id":"update_metadata/1","anchor":"update_metadata/1"}]}]},{"id":"KafkaEx.Server0P8P0","title":"KafkaEx.Server0P8P0","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"handle_call/3","anchor":"handle_call/3"},{"id":"handle_info/2","anchor":"handle_info/2"},{"id":"init/1","anchor":"init/1"},{"id":"kafka_server_api_versions/1","anchor":"kafka_server_api_versions/1"},{"id":"kafka_server_consumer_group/1","anchor":"kafka_server_consumer_group/1"},{"id":"kafka_server_consumer_group_metadata/1","anchor":"kafka_server_consumer_group_metadata/1"},{"id":"kafka_server_create_topics/3","anchor":"kafka_server_create_topics/3"},{"id":"kafka_server_delete_topics/3","anchor":"kafka_server_delete_topics/3"},{"id":"kafka_server_fetch/2","anchor":"kafka_server_fetch/2"},{"id":"kafka_server_heartbeat/3","anchor":"kafka_server_heartbeat/3"},{"id":"kafka_server_init/1","anchor":"kafka_server_init/1"},{"id":"kafka_server_join_group/3","anchor":"kafka_server_join_group/3"},{"id":"kafka_server_leave_group/3","anchor":"kafka_server_leave_group/3"},{"id":"kafka_server_metadata/2","anchor":"kafka_server_metadata/2"},{"id":"kafka_server_offset/4","anchor":"kafka_server_offset/4"},{"id":"kafka_server_offset_commit/2","anchor":"kafka_server_offset_commit/2"},{"id":"kafka_server_offset_fetch/2","anchor":"kafka_server_offset_fetch/2"},{"id":"kafka_server_produce/2","anchor":"kafka_server_produce/2"},{"id":"kafka_server_produce_send_request/4","anchor":"kafka_server_produce_send_request/4"},{"id":"kafka_server_sync_group/3","anchor":"kafka_server_sync_group/3"},{"id":"kafka_server_update_consumer_metadata/1","anchor":"kafka_server_update_consumer_metadata/1"},{"id":"kafka_server_update_metadata/1","anchor":"kafka_server_update_metadata/1"},{"id":"retrieve_metadata/5","anchor":"retrieve_metadata/5"},{"id":"retrieve_metadata/7","anchor":"retrieve_metadata/7"},{"id":"retrieve_metadata_with_version/7","anchor":"retrieve_metadata_with_version/7"},{"id":"start_link/2","anchor":"start_link/2"},{"id":"terminate/2","anchor":"terminate/2"},{"id":"update_metadata/1","anchor":"update_metadata/1"}]}]},{"id":"KafkaEx.Server0P8P2","title":"KafkaEx.Server0P8P2","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"consumer_group?/1","anchor":"consumer_group?/1"},{"id":"consumer_group_if_auto_commit?/2","anchor":"consumer_group_if_auto_commit?/2"},{"id":"handle_call/3","anchor":"handle_call/3"},{"id":"handle_info/2","anchor":"handle_info/2"},{"id":"init/1","anchor":"init/1"},{"id":"kafka_server_api_versions/1","anchor":"kafka_server_api_versions/1"},{"id":"kafka_server_consumer_group/1","anchor":"kafka_server_consumer_group/1"},{"id":"kafka_server_consumer_group_metadata/1","anchor":"kafka_server_consumer_group_metadata/1"},{"id":"kafka_server_create_topics/3","anchor":"kafka_server_create_topics/3"},{"id":"kafka_server_delete_topics/3","anchor":"kafka_server_delete_topics/3"},{"id":"kafka_server_fetch/2","anchor":"kafka_server_fetch/2"},{"id":"kafka_server_heartbeat/3","anchor":"kafka_server_heartbeat/3"},{"id":"kafka_server_init/1","anchor":"kafka_server_init/1"},{"id":"kafka_server_join_group/3","anchor":"kafka_server_join_group/3"},{"id":"kafka_server_leave_group/3","anchor":"kafka_server_leave_group/3"},{"id":"kafka_server_metadata/2","anchor":"kafka_server_metadata/2"},{"id":"kafka_server_offset/4","anchor":"kafka_server_offset/4"},{"id":"kafka_server_offset_commit/2","anchor":"kafka_server_offset_commit/2"},{"id":"kafka_server_offset_fetch/2","anchor":"kafka_server_offset_fetch/2"},{"id":"kafka_server_produce/2","anchor":"kafka_server_produce/2"},{"id":"kafka_server_produce_send_request/4","anchor":"kafka_server_produce_send_request/4"},{"id":"kafka_server_sync_group/3","anchor":"kafka_server_sync_group/3"},{"id":"kafka_server_update_consumer_metadata/1","anchor":"kafka_server_update_consumer_metadata/1"},{"id":"kafka_server_update_metadata/1","anchor":"kafka_server_update_metadata/1"},{"id":"retrieve_metadata/5","anchor":"retrieve_metadata/5"},{"id":"retrieve_metadata/7","anchor":"retrieve_metadata/7"},{"id":"retrieve_metadata_with_version/7","anchor":"retrieve_metadata_with_version/7"},{"id":"start_link/2","anchor":"start_link/2"},{"id":"terminate/2","anchor":"terminate/2"},{"id":"update_consumer_metadata/3","anchor":"update_consumer_metadata/3"},{"id":"update_metadata/1","anchor":"update_metadata/1"}]}]},{"id":"KafkaEx.Server0P9P0","title":"KafkaEx.Server0P9P0","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"broker_for_consumer_group_with_update/2","anchor":"broker_for_consumer_group_with_update/2"},{"id":"consumer_group?/1","anchor":"consumer_group?/1"},{"id":"handle_call/3","anchor":"handle_call/3"},{"id":"handle_info/2","anchor":"handle_info/2"},{"id":"init/1","anchor":"init/1"},{"id":"kafka_server_api_versions/1","anchor":"kafka_server_api_versions/1"},{"id":"kafka_server_consumer_group/1","anchor":"kafka_server_consumer_group/1"},{"id":"kafka_server_consumer_group_metadata/1","anchor":"kafka_server_consumer_group_metadata/1"},{"id":"kafka_server_create_topics/3","anchor":"kafka_server_create_topics/3"},{"id":"kafka_server_delete_topics/3","anchor":"kafka_server_delete_topics/3"},{"id":"kafka_server_fetch/2","anchor":"kafka_server_fetch/2"},{"id":"kafka_server_heartbeat/3","anchor":"kafka_server_heartbeat/3"},{"id":"kafka_server_init/1","anchor":"kafka_server_init/1"},{"id":"kafka_server_join_group/3","anchor":"kafka_server_join_group/3"},{"id":"kafka_server_leave_group/3","anchor":"kafka_server_leave_group/3"},{"id":"kafka_server_metadata/2","anchor":"kafka_server_metadata/2"},{"id":"kafka_server_offset/4","anchor":"kafka_server_offset/4"},{"id":"kafka_server_offset_commit/2","anchor":"kafka_server_offset_commit/2"},{"id":"kafka_server_offset_fetch/2","anchor":"kafka_server_offset_fetch/2"},{"id":"kafka_server_produce/2","anchor":"kafka_server_produce/2"},{"id":"kafka_server_produce_send_request/4","anchor":"kafka_server_produce_send_request/4"},{"id":"kafka_server_sync_group/3","anchor":"kafka_server_sync_group/3"},{"id":"kafka_server_update_consumer_metadata/1","anchor":"kafka_server_update_consumer_metadata/1"},{"id":"kafka_server_update_metadata/1","anchor":"kafka_server_update_metadata/1"},{"id":"retrieve_metadata/5","anchor":"retrieve_metadata/5"},{"id":"retrieve_metadata/7","anchor":"retrieve_metadata/7"},{"id":"retrieve_metadata_with_version/7","anchor":"retrieve_metadata_with_version/7"},{"id":"start_link/2","anchor":"start_link/2"},{"id":"terminate/2","anchor":"terminate/2"},{"id":"update_consumer_metadata/3","anchor":"update_consumer_metadata/3"},{"id":"update_metadata/1","anchor":"update_metadata/1"}]}]},{"id":"KafkaEx.Socket","title":"KafkaEx.Socket","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"close/1","anchor":"close/1"},{"id":"create/4","anchor":"create/4"},{"id":"info/1","anchor":"info/1"},{"id":"open?/1","anchor":"open?/1"},{"id":"recv/2","anchor":"recv/2"},{"id":"recv/3","anchor":"recv/3"},{"id":"send/2","anchor":"send/2"},{"id":"setopts/2","anchor":"setopts/2"}]}]},{"id":"KafkaEx.Utils.Murmur","title":"KafkaEx.Utils.Murmur","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"murmur2/1","anchor":"murmur2/1"},{"id":"umurmur2/1","anchor":"umurmur2/1"},{"id":"umurmur2_legacy/1","anchor":"umurmur2_legacy/1"}]}]}],"tasks":[]}